/**
 * Bundle of @devexpress/dx-vue-grid
 * Generated: 2018-11-07
 * Version: 1.9.0
 * License: https://js.devexpress.com/Licensing
 */

(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@devexpress/dx-vue-core'), require('@devexpress/dx-grid-core'), require('@devexpress/dx-core')) :
  typeof define === 'function' && define.amd ? define(['exports', '@devexpress/dx-vue-core', '@devexpress/dx-grid-core', '@devexpress/dx-core'], factory) :
  (factory((global.DevExpress = global.DevExpress || {}, global.DevExpress.DXVueGrid = {}),global.DevExpress.DXVueCore,global.DevExpress.DXGridCore,global.DevExpress.DXCore));
}(this, (function (exports,dxVueCore,dxGridCore,dxCore) { 'use strict';

  var GridCore = {
    name: 'GridCore',
    props: {
      rows: {
        type: Array,
        required: true
      },
      getRowId: {
        type: Function
      },
      getCellValue: {
        type: Function
      },
      columns: {
        type: Array,
        required: true
      },
      rootComponent: {
        type: Object,
        required: true
      }
    },
    render: function render() {
      var h = arguments[0];
      var rows = this.rows,
          columns = this.columns,
          getRowId = this.getRowId,
          getCellValue = this.getCellValue,
          Root = this.rootComponent;


      return h(dxVueCore.DxPlugin, [h(dxVueCore.DxGetter, {
        attrs: { name: 'rows', value: rows }
      }), h(dxVueCore.DxGetter, {
        attrs: { name: 'getRowId', value: dxGridCore.rowIdGetter(getRowId, rows) }
      }), h(dxVueCore.DxGetter, {
        attrs: { name: 'columns', value: columns }
      }), h(dxVueCore.DxGetter, {
        attrs: { name: 'getCellValue', value: dxGridCore.cellValueGetter(getCellValue, columns) }
      }), h(
        dxVueCore.DxTemplate,
        {
          attrs: { name: 'root' }
        },
        [h(Root, [h(dxVueCore.DxTemplatePlaceholder, {
          attrs: { name: 'header' }
        }), h(dxVueCore.DxTemplatePlaceholder, {
          attrs: { name: 'body' }
        }), h(dxVueCore.DxTemplatePlaceholder, {
          attrs: { name: 'footer' }
        })])]
      )]);
    }
  };

  var DxGrid = {
    name: 'DxGrid',
    functional: true,
    render: function render(h, context) {
      return h(dxVueCore.DxPluginHost, [h(GridCore, context.data), context.children]);
    }
  };

  var nestRE = /^(attrs|props|on|nativeOn|class|style|hook)$/;

  var babelHelperVueJsxMergeProps = function mergeJSXProps(objs) {
    return objs.reduce(function (a, b) {
      var aa, bb, key, nestedKey, temp;
      for (key in b) {
        aa = a[key];
        bb = b[key];
        if (aa && nestRE.test(key)) {
          // normalize class
          if (key === 'class') {
            if (typeof aa === 'string') {
              temp = aa;
              a[key] = aa = {};
              aa[temp] = true;
            }
            if (typeof bb === 'string') {
              temp = bb;
              b[key] = bb = {};
              bb[temp] = true;
            }
          }
          if (key === 'on' || key === 'nativeOn' || key === 'hook') {
            // merge functions
            for (nestedKey in bb) {
              aa[nestedKey] = mergeFn(aa[nestedKey], bb[nestedKey]);
            }
          } else if (Array.isArray(aa)) {
            a[key] = aa.concat(bb);
          } else if (Array.isArray(bb)) {
            a[key] = [aa].concat(bb);
          } else {
            for (nestedKey in bb) {
              aa[nestedKey] = bb[nestedKey];
            }
          }
        } else {
          a[key] = b[key];
        }
      }
      return a;
    }, {});
  };

  function mergeFn(a, b) {
    return function () {
      a && a.apply(this, arguments);
      b && b.apply(this, arguments);
    };
  }

  var defineProperty = function (obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  };

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  var objectWithoutProperties = function (obj, keys) {
    var target = {};

    for (var i in obj) {
      if (keys.indexOf(i) >= 0) continue;
      if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
      target[i] = obj[i];
    }

    return target;
  };

  var slicedToArray = function () {
    function sliceIterator(arr, i) {
      var _arr = [];
      var _n = true;
      var _d = false;
      var _e = undefined;

      try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);

          if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;
        _e = err;
      } finally {
        try {
          if (!_n && _i["return"]) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }

      return _arr;
    }

    return function (arr, i) {
      if (Array.isArray(arr)) {
        return arr;
      } else if (Symbol.iterator in Object(arr)) {
        return sliceIterator(arr, i);
      } else {
        throw new TypeError("Invalid attempt to destructure non-iterable instance");
      }
    };
  }();

  var RowPlaceholder = {
    props: {
      tableRow: {
        type: Object,
        required: true
      },
      height: {
        type: [Number, String]
      }
    },
    render: function render() {
      var h = arguments[0];

      return h(
        dxVueCore.DxTemplatePlaceholder,
        babelHelperVueJsxMergeProps([{
          attrs: {
            name: 'tableRow'
          }
        }, { attrs: _extends({}, this.$props) }]),
        [this.$slots.default]
      );
    }
  };

  var CellPlaceholder = {
    props: {
      tableColumn: {
        type: Object,
        required: true
      },
      tableRow: {
        type: Object,
        required: true
      },
      colSpan: {
        type: Number,
        required: true
      },
      rowSpan: {
        type: Number
      }
    },
    render: function render() {
      var h = arguments[0];

      return h(dxVueCore.DxTemplatePlaceholder, babelHelperVueJsxMergeProps([{
        attrs: {
          name: 'tableCell'
        }
      }, { attrs: _extends({}, this.$props) }]));
    }
  };

  var tableHeaderRows = [];
  var tableBodyRowsComputed = function tableBodyRowsComputed(_ref) {
    var rows = _ref.rows,
        getRowId = _ref.getRowId;
    return dxGridCore.tableRowsWithDataRows(rows, getRowId);
  };

  var DxTable = {
    name: 'DxTable',
    props: {
      layoutComponent: {
        type: Object,
        required: true
      },
      tableComponent: {
        type: Object,
        required: true
      },
      headComponent: {
        type: Object,
        required: true
      },
      bodyComponent: {
        type: Object,
        required: true
      },
      containerComponent: {
        type: Object,
        required: true
      },
      cellComponent: {
        type: Object,
        required: true
      },
      rowComponent: {
        type: Object,
        required: true
      },
      stubRowComponent: {
        type: Object,
        required: true
      },
      stubCellComponent: {
        type: Object,
        required: true
      },
      stubHeaderCellComponent: {
        type: Object,
        required: true
      },
      noDataRowComponent: {
        type: Object,
        required: true
      },
      noDataCellComponent: {
        type: Object,
        required: true
      },
      columnExtensions: {
        type: Array
      },
      messages: {
        type: Object
      }
    },
    render: function render() {
      var h = arguments[0];
      var Layout = this.layoutComponent,
          Cell = this.cellComponent,
          Row = this.rowComponent,
          NoDataRow = this.noDataRowComponent,
          NoDataCell = this.noDataCellComponent,
          StubRow = this.stubRowComponent,
          StubCell = this.stubCellComponent,
          StubHeaderCell = this.stubHeaderCellComponent,
          columnExtensions = this.columnExtensions,
          containerComponent = this.containerComponent,
          tableComponent = this.tableComponent,
          headComponent = this.headComponent,
          bodyComponent = this.bodyComponent,
          messages = this.messages;


      var getMessage = dxCore.getMessagesFormatter(messages);
      var tableColumnsComputed = function tableColumnsComputed(_ref2) {
        var columns = _ref2.columns;
        return dxGridCore.tableColumnsWithDataRows(columns, columnExtensions);
      };

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxTable'
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'tableHeaderRows', value: tableHeaderRows }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'tableBodyRows', computed: tableBodyRowsComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'tableColumns', computed: tableColumnsComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'getTableCellColSpan', value: dxGridCore.tableCellColSpanGetter }
        }), h(
          dxVueCore.DxTemplate,
          {
            attrs: { name: 'body' }
          },
          [h(dxVueCore.DxTemplatePlaceholder, {
            attrs: { name: 'table' }
          })]
        ), h(
          dxVueCore.DxTemplate,
          {
            attrs: { name: 'table' }
          },
          [h(dxVueCore.DxTemplateConnector, [function (_ref3) {
            var _ref3$getters = _ref3.getters,
                headerRows = _ref3$getters.tableHeaderRows,
                bodyRows = _ref3$getters.tableBodyRows,
                columns = _ref3$getters.tableColumns,
                getTableCellColSpan = _ref3$getters.getTableCellColSpan;
            return h(Layout, {
              attrs: {
                tableComponent: tableComponent,
                headComponent: headComponent,
                bodyComponent: bodyComponent,
                containerComponent: containerComponent,
                headerRows: headerRows,
                bodyRows: bodyRows,
                columns: columns,
                rowComponent: RowPlaceholder,
                cellComponent: CellPlaceholder,
                getCellColSpan: getTableCellColSpan
              }
            });
          }])]
        ), h(
          dxVueCore.DxTemplate,
          {
            attrs: { name: 'tableCell' }
          },
          [function (_ref4) {
            var attrs = _ref4.attrs,
                listeners = _ref4.listeners;
            return h(dxVueCore.DxTemplateConnector, [function (_ref5) {
              var headerRows = _ref5.getters.tableHeaderRows;
              return dxGridCore.isHeaderStubTableCell(attrs.tableRow, headerRows) ? h(StubHeaderCell, { attrs: _extends({}, attrs), on: _extends({}, listeners) }) : h(StubCell, { attrs: _extends({}, attrs), on: _extends({}, listeners) });
            }]);
          }]
        ), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableCell',
              predicate: function predicate(_ref6) {
                var _ref6$attrs = _ref6.attrs,
                    tableRow = _ref6$attrs.tableRow,
                    tableColumn = _ref6$attrs.tableColumn;
                return dxGridCore.isDataTableCell(tableRow, tableColumn);
              }
            }
          },
          [function (_ref7) {
            var attrs = _ref7.attrs,
                listeners = _ref7.listeners;
            return h(dxVueCore.DxTemplateConnector, [function (_ref8) {
              var getCellValue = _ref8.getters.getCellValue;

              var value = getCellValue(attrs.tableRow.row, attrs.tableColumn.column.name);
              return h(
                dxVueCore.DxTemplatePlaceholder,
                {
                  attrs: {
                    name: 'valueFormatter',
                    row: attrs.tableRow.row,
                    column: attrs.tableColumn.column,
                    value: value
                  }
                },
                [function (content) {
                  return h(
                    Cell,
                    babelHelperVueJsxMergeProps([{ attrs: _extends({}, attrs), on: _extends({}, listeners) }, {
                      attrs: {
                        row: attrs.tableRow.row,
                        column: attrs.tableColumn.column,
                        value: value
                      }
                    }]),
                    [content]
                  );
                }]
              );
            }]);
          }]
        ), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableCell',
              predicate: function predicate(_ref9) {
                var tableRow = _ref9.attrs.tableRow;
                return dxGridCore.isNoDataTableRow(tableRow);
              }
            }
          },
          [function (_ref10) {
            var attrs = _ref10.attrs,
                listeners = _ref10.listeners;
            return h(dxVueCore.DxTemplateConnector, [function (_ref11) {
              var tableColumns = _ref11.getters.tableColumns;

              if (dxGridCore.isNoDataTableCell(attrs.tableColumn, tableColumns)) {
                return h(NoDataCell, babelHelperVueJsxMergeProps([{ attrs: _extends({}, attrs), on: _extends({}, listeners) }, {
                  attrs: {
                    getMessage: getMessage
                  }
                }]));
              }
              return null;
            }]);
          }]
        ), h(
          dxVueCore.DxTemplate,
          {
            attrs: { name: 'tableRow' }
          },
          [function (_ref12) {
            var attrs = _ref12.attrs,
                listeners = _ref12.listeners,
                slots = _ref12.slots;
            return h(
              StubRow,
              { attrs: _extends({}, attrs), on: _extends({}, listeners) },
              [slots.default]
            );
          }]
        ), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableRow',
              predicate: function predicate(_ref13) {
                var tableRow = _ref13.attrs.tableRow;
                return dxGridCore.isDataTableRow(tableRow);
              }
            }
          },
          [function (_ref14) {
            var attrs = _ref14.attrs,
                listeners = _ref14.listeners,
                slots = _ref14.slots;
            return h(
              Row,
              babelHelperVueJsxMergeProps([{ attrs: _extends({}, attrs), on: _extends({}, listeners) }, {
                attrs: {
                  row: attrs.tableRow.row
                }
              }]),
              [slots.default]
            );
          }]
        ), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableRow',
              predicate: function predicate(_ref15) {
                var tableRow = _ref15.attrs.tableRow;
                return dxGridCore.isNoDataTableRow(tableRow);
              }
            }
          },
          [function (_ref16) {
            var attrs = _ref16.attrs,
                listeners = _ref16.listeners,
                slots = _ref16.slots;
            return h(
              NoDataRow,
              { attrs: _extends({}, attrs), on: _extends({}, listeners) },
              [slots.default]
            );
          }]
        )]
      );
    }
  };

  var tableHeaderRowsComputed = function tableHeaderRowsComputed(_ref) {
    var tableHeaderRows = _ref.tableHeaderRows;
    return dxGridCore.tableRowsWithHeading(tableHeaderRows);
  };

  var pluginDependencies = [{ name: 'DxTable' }];

  var DxTableHeaderRow = {
    name: 'DxTableHeaderRow',
    props: {
      showSortingControls: {
        type: Boolean
      },
      showGroupingControls: {
        type: Boolean
      },
      cellComponent: {
        type: Object,
        required: true
      },
      rowComponent: {
        type: Object,
        required: true
      }
    },
    render: function render() {
      var _this = this;

      var h = arguments[0];
      var HeaderCell = this.cellComponent,
          HeaderRow = this.rowComponent;


      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxTableHeaderRow',
            dependencies: pluginDependencies
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'tableHeaderRows', computed: tableHeaderRowsComputed }
        }), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableCell',
              predicate: function predicate(_ref2) {
                var _ref2$attrs = _ref2.attrs,
                    tableRow = _ref2$attrs.tableRow,
                    tableColumn = _ref2$attrs.tableColumn;
                return dxGridCore.isHeadingTableCell(tableRow, tableColumn);
              }
            }
          },
          [function (_ref3) {
            var attrs = _ref3.attrs,
                listeners = _ref3.listeners;
            return h(dxVueCore.DxTemplateConnector, [function (_ref4) {
              var _ref4$getters = _ref4.getters,
                  sorting = _ref4$getters.sorting,
                  tableColumns = _ref4$getters.tableColumns,
                  isColumnSortingEnabled = _ref4$getters.isColumnSortingEnabled,
                  isColumnGroupingEnabled = _ref4$getters.isColumnGroupingEnabled,
                  _ref4$actions = _ref4.actions,
                  changeColumnSorting = _ref4$actions.changeColumnSorting,
                  changeColumnGrouping = _ref4$actions.changeColumnGrouping;
              var columnName = attrs.tableColumn.column.name;

              var atLeastOneDataColumn = tableColumns.filter(function (_ref5) {
                var type = _ref5.type;
                return type === dxGridCore.TABLE_DATA_TYPE;
              }).length > 1;
              var sortingEnabled = isColumnSortingEnabled && isColumnSortingEnabled(columnName);
              var groupingEnabled = isColumnGroupingEnabled && isColumnGroupingEnabled(columnName) && atLeastOneDataColumn;

              return h(
                HeaderCell,
                babelHelperVueJsxMergeProps([{ attrs: _extends({}, attrs), on: _extends({}, listeners) }, {
                  attrs: {
                    column: attrs.tableColumn.column,
                    showSortingControls: _this.showSortingControls,
                    showGroupingControls: _this.showGroupingControls,
                    sortingEnabled: sortingEnabled,
                    groupingEnabled: groupingEnabled,
                    sortingDirection: _this.showSortingControls ? dxGridCore.getColumnSortingDirection(sorting, columnName) : undefined
                  },
                  on: {
                    'sort': function sort(_ref6) {
                      var direction = _ref6.direction,
                          keepOther = _ref6.keepOther;
                      return changeColumnSorting({ columnName: columnName, direction: direction, keepOther: keepOther });
                    },
                    'group': function group() {
                      return changeColumnGrouping({ columnName: columnName });
                    }
                  }
                }]),
                [h(dxVueCore.DxTemplatePlaceholder, {
                  slot: 'before',
                  attrs: { name: 'tableHeaderCellBefore',
                    column: attrs.tableColumn.column
                  }
                })]
              );
            }]);
          }]
        ), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableRow',
              predicate: function predicate(_ref7) {
                var tableRow = _ref7.attrs.tableRow;
                return dxGridCore.isHeadingTableRow(tableRow);
              }
            }
          },
          [function (_ref8) {
            var attrs = _ref8.attrs,
                listeners = _ref8.listeners,
                slots = _ref8.slots;
            return h(
              HeaderRow,
              { attrs: _extends({}, attrs), on: _extends({}, listeners) },
              [slots.default]
            );
          }]
        )]
      );
    }
  };

  var pluginDependencies$1 = [{ name: 'DxSortingState' }];

  var DxIntegratedSorting = {
    name: 'DxIntegratedSorting',
    props: {
      columnExtensions: {
        type: Array
      }
    },
    render: function render() {
      var h = arguments[0];
      var columnExtensions = this.columnExtensions;

      var getColumnCompare = function getColumnCompare(columnName) {
        return dxGridCore.getColumnExtension(columnExtensions, columnName).compare;
      };

      var rowsComputed = function rowsComputed(_ref) {
        var rows = _ref.rows,
            sorting = _ref.sorting,
            getCellValue = _ref.getCellValue,
            isGroupRow = _ref.isGroupRow,
            getRowLevelKey = _ref.getRowLevelKey;
        return dxGridCore.sortedRows(rows, sorting, getCellValue, getColumnCompare, isGroupRow, getRowLevelKey);
      };

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxIntegratedSorting',
            dependencies: pluginDependencies$1
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'rows', computed: rowsComputed }
        })]
      );
    }
  };

  var DxSortingState = {
    name: 'DxSortingState',
    props: {
      sorting: {
        type: Array,
        required: true
      },
      columnExtensions: {
        type: Array
      },
      columnSortingEnabled: {
        type: Boolean,
        default: true
      }
    },
    methods: {
      changeColumnSorting: function changeColumnSorting(payload) {
        var persistentSortedColumns = dxGridCore.getPersistentSortedColumns(this.sorting, this.columnExtensions);
        var keepOther = dxGridCore.calculateKeepOther(this.sorting, payload.keepOther, persistentSortedColumns);
        this.$emit('update:sorting', dxGridCore.changeColumnSorting({ sorting: this.sorting }, _extends({}, payload, { keepOther: keepOther })).sorting);
      }
    },

    render: function render() {
      var h = arguments[0];
      var columnExtensions = this.columnExtensions,
          columnSortingEnabled = this.columnSortingEnabled;

      var columnExtensionValueGetter = function columnExtensionValueGetter(extensions, defaultValue) {
        return dxGridCore.getColumnExtensionValueGetter(extensions, 'sortingEnabled', defaultValue);
      };

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxSortingState'
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'sorting', value: this.sorting }
        }), h(dxVueCore.DxGetter, {
          attrs: {
            name: 'isColumnSortingEnabled',
            value: columnExtensionValueGetter(columnExtensions, columnSortingEnabled)
          }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'changeColumnSorting', action: this.changeColumnSorting }
        })]
      );
    }
  };

  var DxToolbar = {
    name: 'DxToolbar',
    props: {
      rootComponent: {
        type: Object,
        required: true
      },
      flexibleSpaceComponent: {
        type: Object,
        required: true
      }
    },
    render: function render() {
      var h = arguments[0];
      var Root = this.rootComponent,
          FlexibleSpaceComponent = this.flexibleSpaceComponent;

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxToolbar'
          }
        },
        [h(
          dxVueCore.DxTemplate,
          {
            attrs: { name: 'header' }
          },
          [h(Root, [h(dxVueCore.DxTemplatePlaceholder, {
            attrs: { name: 'toolbarContent' }
          })]), h(dxVueCore.DxTemplatePlaceholder)]
        ), h(
          dxVueCore.DxTemplate,
          {
            attrs: { name: 'toolbarContent' }
          },
          [h(FlexibleSpaceComponent)]
        )]
      );
    }
  };

  var TableLayout = {
    props: {
      columns: {
        type: Array,
        required: true
      },
      layoutComponent: {
        type: Object,
        required: true
      },
      minColumnWidth: {
        type: Number,
        required: true
      }
    },
    methods: {
      getColumns: function getColumns() {
        var columns = this.columns;


        var result = columns;

        var isFixedWidth = columns.filter(function (column) {
          return column.width === undefined;
        }).length === 0;
        if (isFixedWidth) {
          result = result.slice();
          result.push({ key: dxGridCore.TABLE_FLEX_TYPE.toString(), type: dxGridCore.TABLE_FLEX_TYPE });
        }

        return result;
      }
    },
    render: function render() {
      var h = arguments[0];
      var minColumnWidth = this.minColumnWidth,
          Layout = this.layoutComponent;


      var columns = this.getColumns();
      var minWidth = columns.map(function (column) {
        return column.width || (column.type === dxGridCore.TABLE_FLEX_TYPE ? 0 : minColumnWidth);
      }).reduce(function (acc, width) {
        return acc + width;
      }, 0);

      return h(Layout, babelHelperVueJsxMergeProps([{ attrs: this.$attrs }, {
        attrs: {
          columns: columns,
          minWidth: minWidth,
          minColumnWidth: minColumnWidth
        }
      }]));
    }
  };

  var ColumnGroup = {
    name: 'ColumnGroup',
    props: {
      columns: {
        type: Array,
        required: true
      }
    },
    render: function render() {
      var h = arguments[0];
      var columns = this.columns;


      return h('colgroup', [columns.map(function (column) {
        return h('col', {
          key: column.key,
          style: column.width !== undefined ? { width: column.width + 'px' } : null
        });
      })]);
    }
  };

  var getRowStyle = function getRowStyle(_ref) {
    var row = _ref.row;
    return row.height !== undefined ? { height: row.height + 'px' } : undefined;
  };

  var RowLayout = {
    name: 'RowLayout',
    props: {
      row: {
        required: true
      },
      columns: {
        type: Array,
        required: true
      },
      rowComponent: {
        type: Object,
        required: true
      },
      cellComponent: {
        type: Object,
        required: true
      },
      getCellColSpan: {
        getCellColSpan: Function,
        required: true
      }
    },
    render: function render() {
      var h = arguments[0];
      var row = this.row,
          columns = this.columns,
          Row = this.rowComponent,
          Cell = this.cellComponent,
          getCellColSpan = this.getCellColSpan;

      var getColSpan = function getColSpan(tableRow, tableColumn) {
        return getCellColSpan({ tableRow: tableRow, tableColumn: tableColumn, tableColumns: columns });
      };

      return h(
        Row,
        {
          attrs: {
            tableRow: row
          },
          style: getRowStyle({ row: row })
        },
        [columns.map(function (column) {
          return h(Cell, {
            key: column.key,
            attrs: { tableRow: row,
              tableColumn: column,
              colSpan: getColSpan(row, column)
            }
          });
        })]
      );
    }
  };

  var RowsBlockLayout = {
    name: 'RowsBlockLayout',
    props: {
      rows: {
        type: Array,
        required: true
      },
      columns: {
        type: Array,
        required: true
      },
      blockComponent: {
        type: Object,
        required: true
      },
      rowComponent: {
        type: Object,
        required: true
      },
      cellComponent: {
        type: Object,
        required: true
      },
      getCellColSpan: {
        getCellColSpan: Function,
        required: true
      }
    },
    render: function render() {
      var h = arguments[0];
      var rows = this.rows,
          columns = this.columns,
          Block = this.blockComponent,
          rowComponent = this.rowComponent,
          cellComponent = this.cellComponent,
          getCellColSpan = this.getCellColSpan;


      return h(Block, [rows.map(function (row) {
        return h(RowLayout, {
          key: row.key,
          attrs: { row: row,
            columns: columns,
            rowComponent: rowComponent,
            cellComponent: cellComponent,
            getCellColSpan: getCellColSpan
          }
        });
      })]);
    }
  };

  var StaticTableLayout = {
    props: {
      cellComponent: {
        type: Object,
        required: true
      },
      rowComponent: {
        type: Object,
        required: true
      },
      bodyComponent: {
        type: Object,
        required: true
      },
      headComponent: {
        type: Object
      },
      tableComponent: {
        type: Object,
        required: true
      },
      containerComponent: {
        type: Object,
        required: true
      },
      columns: {
        type: Array,
        required: true
      },
      bodyRows: {
        type: Array,
        required: true
      },
      headerRows: {
        type: Array,
        default: function _default() {
          return [];
        }
      },
      minWidth: {
        type: Number,
        required: true
      },
      getCellColSpan: {
        getCellColSpan: Function,
        required: true
      }
    },
    render: function render() {
      var h = arguments[0];
      var cellComponent = this.cellComponent,
          rowComponent = this.rowComponent,
          bodyComponent = this.bodyComponent,
          headComponent = this.headComponent,
          Table = this.tableComponent,
          Container = this.containerComponent,
          columns = this.columns,
          bodyRows = this.bodyRows,
          headerRows = this.headerRows,
          minWidth = this.minWidth,
          getCellColSpan = this.getCellColSpan;


      return h(Container, [h(
        Table,
        {
          style: { minWidth: minWidth + 'px' }
        },
        [h(ColumnGroup, {
          attrs: { columns: columns }
        }), !!headerRows.length && h(RowsBlockLayout, {
          attrs: {
            rows: headerRows,
            columns: columns,
            blockComponent: headComponent,
            rowComponent: rowComponent,
            cellComponent: cellComponent,
            getCellColSpan: getCellColSpan
          }
        }), h(RowsBlockLayout, {
          attrs: {
            rows: bodyRows,
            columns: columns,
            blockComponent: bodyComponent,
            rowComponent: rowComponent,
            cellComponent: cellComponent,
            getCellColSpan: getCellColSpan
          }
        })]
      )]);
    }
  };

  var VirtualTableLayout = {
    name: 'VirtualTableLayout',
    props: {
      minWidth: {
        type: Number,
        required: true
      },
      minColumnWidth: {
        type: Number,
        required: true
      },
      height: {
        type: Number,
        required: true
      },
      headerRows: {
        type: Array,
        default: function _default() {
          return [];
        }
      },
      bodyRows: {
        type: Array,
        required: true
      },
      columns: {
        type: Array,
        required: true
      },
      cellComponent: {
        type: Object,
        required: true
      },
      rowComponent: {
        type: Object,
        required: true
      },
      bodyComponent: {
        type: Object,
        required: true
      },
      headComponent: {
        type: Object,
        default: function _default() {
          return null;
        }
      },
      tableComponent: {
        type: Object,
        required: true
      },
      headTableComponent: {
        type: Object,
        default: function _default() {
          return null;
        }
      },
      containerComponent: {
        type: Object,
        required: true
      },
      estimatedRowHeight: {
        type: Number,
        required: true
      },
      getCellColSpan: {
        type: Function,
        required: true
      }
    },
    data: function data() {
      return {
        rowHeights: new Map(),
        viewportTop: 0,
        viewportLeft: 0
      };
    },
    mounted: function mounted() {
      this.storeRowHeights();
    },
    updated: function updated() {
      this.storeRowHeights();
    },

    watch: {
      headerRows: function headerRows(_headerRows) {
        var prevRowHeight = this.rowHeights,
            bodyRows = this.bodyRows;

        var rowHeights = [_headerRows, bodyRows].reduce(function (acc, row) {
          var rowHeight = prevRowHeight.get(row.key);
          if (rowHeight !== undefined) {
            acc.set(row.key, rowHeight);
          }
          return acc;
        }, new Map());
        this.rowHeights = rowHeights;
      },
      bodyRows: function bodyRows(_bodyRows) {
        var prevRowHeight = this.rowHeights,
            headerRows = this.headerRows;

        var rowHeights = [headerRows, _bodyRows].reduce(function (acc, row) {
          var rowHeight = prevRowHeight.get(row.key);
          if (rowHeight !== undefined) {
            acc.set(row.key, rowHeight);
          }
          return acc;
        }, new Map());
        this.rowHeights = rowHeights;
      }
    },
    methods: {
      getRowHeight: function getRowHeight(row) {
        var storedHeight = this.rowHeights.get(row.key);
        if (storedHeight !== undefined) return storedHeight;
        if (row.height) return row.height;
        return this.estimatedRowHeight;
      },
      storeRowHeights: function storeRowHeights() {
        var _this = this;

        var rowsWithChangedHeights = Object.keys(this.$refs).map(function (node) {
          return _this.$refs[node];
        }).filter(function (node) {
          return !!node;
        }).map(function (node) {
          return [node.$attrs.row, node.$el.getBoundingClientRect().height];
        }).filter(function (_ref) {
          var _ref2 = slicedToArray(_ref, 2),
              row = _ref2[0],
              height = _ref2[1];

          return height !== _this.getRowHeight(row);
        });

        if (rowsWithChangedHeights.length) {
          var newRowHeights = new Map();
          rowsWithChangedHeights.forEach(function (_ref3) {
            var _ref4 = slicedToArray(_ref3, 2),
                row = _ref4[0],
                height = _ref4[1];

            return newRowHeights.set(row.key, height);
          });

          this.rowHeights = newRowHeights;
        }
      },
      updateViewport: function updateViewport(e) {
        var node = e.target;

        if (node !== e.currentTarget) {
          return;
        }

        // NOTE: prevent iOS to flicker in bounces
        if (node.scrollTop < 0 || node.scrollLeft < 0 || node.scrollLeft + node.clientWidth > Math.max(node.scrollWidth, node.clientWidth) || node.scrollTop + node.clientHeight > Math.max(node.scrollHeight, node.clientHeight)) {
          return;
        }

        this.viewportTop = node.scrollTop;
        this.viewportLeft = node.scrollLeft;
      },
      renderRowsBlock: function renderRowsBlock(collapsedGrid, Table, Body) {
        var h = this.$createElement;
        var minWidth = this.minWidth,
            Row = this.rowComponent,
            Cell = this.cellComponent;


        return h(
          Table,
          {
            style: { minWidth: minWidth + 'px' },
            attrs: { minWidth: minWidth + 'px'
            }
          },
          [h(ColumnGroup, {
            attrs: {
              columns: collapsedGrid.columns
            }
          }), h(Body, [collapsedGrid.rows.map(function (visibleRow) {
            var row = visibleRow.row,
                _visibleRow$cells = visibleRow.cells,
                cells = _visibleRow$cells === undefined ? [] : _visibleRow$cells;

            return h(
              dxVueCore.DxRefHolder,
              {
                key: row.key,
                ref: '' + row.key,
                attrs: { row: row
                }
              },
              [h(
                Row,
                {
                  attrs: {
                    tableRow: row,
                    height: row.height !== undefined ? row.height + 'px' : undefined
                  }
                },
                [cells.map(function (cell) {
                  var column = cell.column;

                  return h(Cell, {
                    key: column.key,
                    attrs: { tableRow: row,
                      tableColumn: column,

                      colSpan: cell.colSpan
                    },
                    style: column.animationState });
                })]
              )]
            );
          })])]
        );
      }
    },
    render: function render() {
      var _this2 = this;

      var h = arguments[0];
      var headerRows = this.headerRows,
          bodyRows = this.bodyRows,
          columns = this.columns,
          minColumnWidth = this.minColumnWidth,
          height = this.height,
          Container = this.containerComponent,
          HeadTable = this.headTableComponent,
          Table = this.tableComponent,
          Head = this.headComponent,
          Body = this.bodyComponent,
          getCellColSpan = this.getCellColSpan,
          updateViewport = this.updateViewport,
          renderRowsBlock = this.renderRowsBlock;


      return h(dxVueCore.DxSizer, [function (_ref5) {
        var width = _ref5.width;

        var headHeight = headerRows.reduce(function (acc, row) {
          return acc + _this2.getRowHeight(row);
        }, 0);
        var getColSpan = function getColSpan(tableRow, tableColumn) {
          return getCellColSpan({ tableRow: tableRow, tableColumn: tableColumn, tableColumns: columns });
        };
        var collapsedHeaderGrid = dxGridCore.getCollapsedGrid({
          rows: headerRows,
          columns: columns,
          top: 0,
          left: _this2.viewportLeft,
          width: width,
          height: headHeight,
          getColumnWidth: function getColumnWidth(column) {
            return column.width || minColumnWidth;
          },
          getRowHeight: _this2.getRowHeight,
          getColSpan: getColSpan
        });
        var collapsedBodyGrid = dxGridCore.getCollapsedGrid({
          rows: bodyRows,
          columns: columns,
          top: _this2.viewportTop,
          left: _this2.viewportLeft,
          width: width,
          height: height - headHeight,
          getColumnWidth: function getColumnWidth(column) {
            return column.width || minColumnWidth;
          },
          getRowHeight: _this2.getRowHeight,
          getColSpan: getColSpan
        });
        return h(
          Container,
          {
            style: { height: height + 'px' },
            on: {
              'scroll': updateViewport
            }
          },
          [!!headerRows.length && renderRowsBlock(collapsedHeaderGrid, HeadTable, Head), renderRowsBlock(collapsedBodyGrid, Table, Body)]
        );
      }]);
    }
  };

  var columnExtensionValueGetter = function columnExtensionValueGetter(columnExtensions, defaultValue) {
    return dxGridCore.getColumnExtensionValueGetter(columnExtensions, 'filteringEnabled', defaultValue);
  };
  var filterExpressionComputed = function filterExpressionComputed(_ref) {
    var filters = _ref.filters,
        filterExpressionValue = _ref.filterExpression;
    return dxGridCore.filterExpression(filters, filterExpressionValue);
  };

  var DxFilteringState = {
    name: 'DxFilteringState',
    props: {
      filters: {
        type: Array,
        required: true
      },
      columnExtensions: {
        type: Array
      },
      columnFilteringEnabled: {
        type: Boolean,
        default: true
      }
    },
    methods: {
      changeColumnFilter: function changeColumnFilter(payload) {
        this.$emit('update:filters', dxGridCore.changeColumnFilter(this.filters, payload));
      }
    },
    render: function render() {
      var h = arguments[0];
      var filters = this.filters,
          columnExtensions = this.columnExtensions,
          columnFilteringEnabled = this.columnFilteringEnabled;


      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxFilteringState'
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'filters', value: filters }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'filterExpression', computed: filterExpressionComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: {
            name: 'isColumnFilteringEnabled',
            value: columnExtensionValueGetter(columnExtensions, columnFilteringEnabled)
          }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'changeColumnFilter', action: this.changeColumnFilter }
        })]
      );
    }
  };

  var pluginDependencies$2 = [{ name: 'DxFilteringState', optional: true }, { name: 'DxSearchState', optional: true }];

  var getCollapsedRowsComputed = function getCollapsedRowsComputed(_ref) {
    var rows = _ref.rows;
    return dxGridCore.filteredCollapsedRowsGetter(rows);
  };
  var unwrappedRowsComputed = function unwrappedRowsComputed(_ref2) {
    var rows = _ref2.rows;
    return dxGridCore.unwrappedFilteredRows(rows);
  };

  var DxIntegratedFiltering = {
    name: 'DxIntegratedFiltering',
    props: {
      columnExtensions: {
        type: Array
      }
    },
    render: function render() {
      var h = arguments[0];
      var columnExtensions = this.columnExtensions;

      var getColumnPredicate = function getColumnPredicate(columnName) {
        return dxGridCore.getColumnExtension(columnExtensions, columnName).predicate;
      };

      var rowsComputed = function rowsComputed(_ref3) {
        var rows = _ref3.rows,
            filterExpression = _ref3.filterExpression,
            getCellValue = _ref3.getCellValue,
            getRowLevelKey = _ref3.getRowLevelKey,
            getCollapsedRows = _ref3.getCollapsedRows;
        return dxGridCore.filteredRows(rows, filterExpression, getCellValue, getColumnPredicate, getRowLevelKey, getCollapsedRows);
      };

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxIntegratedFiltering',
            dependencies: pluginDependencies$2
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'rows', computed: rowsComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'getCollapsedRows', computed: getCollapsedRowsComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'rows', computed: unwrappedRowsComputed }
        })]
      );
    }
  };

  DxIntegratedFiltering.defaultPredicate = dxGridCore.defaultFilterPredicate;

  var pluginDependencies$3 = [{ name: 'DxFilteringState' }, { name: 'DxTable' }, { name: 'DxDataTypeProvider', optional: true }];

  var DxTableFilterRow = {
    name: 'DxTableFilterRow',
    props: {
      rowHeight: {
        type: Number
      },
      showFilterSelector: {
        type: Boolean,
        default: false
      },
      messages: {
        type: Object
      },
      cellComponent: {
        type: Object,
        required: true
      },
      rowComponent: {
        type: Object,
        required: true
      },
      filterSelectorComponent: {
        type: Object,
        required: true
      },
      iconComponent: {
        type: Object,
        required: true
      },
      editorComponent: {
        type: Object,
        required: true
      }
    },
    data: function data() {
      return {
        filterOperations: {}
      };
    },
    render: function render() {
      var _this = this;

      var h = arguments[0];
      var rowHeight = this.rowHeight,
          showFilterSelector = this.showFilterSelector,
          FilterCell = this.cellComponent,
          FilterRow = this.rowComponent,
          FilterSelector = this.filterSelectorComponent,
          iconComponent = this.iconComponent,
          EditorComponent = this.editorComponent,
          messages = this.messages,
          filterOperations = this.filterOperations;


      var getMessage = dxCore.getMessagesFormatter(messages);

      var tableHeaderRowsComputed = function tableHeaderRowsComputed(_ref) {
        var tableHeaderRows = _ref.tableHeaderRows;
        return dxGridCore.tableHeaderRowsWithFilter(tableHeaderRows, rowHeight);
      };

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxTableFilterRow',
            dependencies: pluginDependencies$3
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'tableHeaderRows', computed: tableHeaderRowsComputed }
        }), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableCell',
              predicate: function predicate(_ref2) {
                var _ref2$attrs = _ref2.attrs,
                    tableRow = _ref2$attrs.tableRow,
                    tableColumn = _ref2$attrs.tableColumn;
                return dxGridCore.isFilterTableCell(tableRow, tableColumn);
              }
            }
          },
          [function (_ref3) {
            var attrs = _ref3.attrs,
                listeners = _ref3.listeners;
            return h(dxVueCore.DxTemplateConnector, [function (_ref4) {
              var _ref4$getters = _ref4.getters,
                  filters = _ref4$getters.filters,
                  isColumnFilteringEnabled = _ref4$getters.isColumnFilteringEnabled,
                  getAvailableFilterOperations = _ref4$getters.getAvailableFilterOperations,
                  changeColumnFilter = _ref4.actions.changeColumnFilter;
              var columnName = attrs.tableColumn.column.name;

              var filter = dxGridCore.getColumnFilterConfig(filters, columnName);
              var onFilter = function onFilter(config) {
                return changeColumnFilter({ columnName: columnName, config: config });
              };
              var columnFilterOperations = dxGridCore.getColumnFilterOperations(getAvailableFilterOperations, columnName);
              var selectedFilterOperation = filterOperations[columnName] || columnFilterOperations[0];
              var handleFilterOperationChange = function handleFilterOperationChange(value) {
                _this.filterOperations = _extends({}, filterOperations, defineProperty({}, columnName, value));
                if (filter && !dxGridCore.isFilterValueEmpty(filter.value)) {
                  onFilter({ value: filter.value, operation: value });
                }
              };
              var handleFilterValueChange = function handleFilterValueChange(value) {
                onFilter(!dxGridCore.isFilterValueEmpty(value) ? { value: value, operation: selectedFilterOperation } : null);
              };
              var filteringEnabled = isColumnFilteringEnabled(columnName);
              return h(
                dxVueCore.DxTemplatePlaceholder,
                {
                  attrs: {
                    name: 'valueEditor',
                    column: attrs.tableColumn.column,
                    value: filter ? filter.value : undefined
                  },
                  on: {
                    'valueChange': handleFilterValueChange
                  }
                },
                [function (content) {
                  return h(
                    FilterCell,
                    babelHelperVueJsxMergeProps([{ attrs: _extends({}, attrs), on: _extends({}, listeners) }, {
                      attrs: {
                        getMessage: getMessage,
                        column: attrs.tableColumn.column,
                        filter: filter,
                        filteringEnabled: filteringEnabled
                      },
                      on: {
                        'filter': onFilter
                      }
                    }]),
                    [showFilterSelector ? h(FilterSelector, {
                      attrs: {
                        iconComponent: iconComponent,
                        value: selectedFilterOperation,
                        availableValues: columnFilterOperations,

                        disabled: !filteringEnabled,
                        getMessage: getMessage
                      },
                      on: {
                        'changeValue': handleFilterOperationChange
                      }
                    }) : null, content || h(EditorComponent, {
                      attrs: {
                        value: filter ? filter.value : '',
                        disabled: !filteringEnabled,
                        getMessage: getMessage
                      },
                      on: {
                        'changeValue': handleFilterValueChange
                      }
                    })]
                  );
                }]
              );
            }]);
          }]
        ), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableRow',
              predicate: function predicate(_ref5) {
                var tableRow = _ref5.attrs.tableRow;
                return dxGridCore.isFilterTableRow(tableRow);
              }
            }
          },
          [function (_ref6) {
            var attrs = _ref6.attrs,
                listeners = _ref6.listeners,
                slots = _ref6.slots;
            return h(
              FilterRow,
              babelHelperVueJsxMergeProps([{ attrs: _extends({}, attrs), on: _extends({}, listeners) }, {
                attrs: {
                  row: attrs.tableRow.row
                }
              }]),
              [slots.default]
            );
          }]
        )]
      );
    }
  };

  var dependencies = [{ name: 'DxSortingState', optional: true }];

  var callback = function callback(_ref, _ref2, _ref3, _ref4, columnName) {
    var grouping = _ref.grouping;
    var prevGrouping = _ref2.grouping;
    var sorting = _ref3.sorting;
    var changeColumnSorting = _ref4.changeColumnSorting;

    if (!sorting) return;
    var columnSortingIndex = sorting.findIndex(function (columnSorting) {
      return columnSorting.columnName === columnName;
    });
    var prevGroupingIndex = prevGrouping.findIndex(function (columnGrouping) {
      return columnGrouping.columnName === columnName;
    });
    var groupingIndex = grouping.findIndex(function (columnGrouping) {
      return columnGrouping.columnName === columnName;
    });

    if (columnSortingIndex === -1 || prevGroupingIndex === prevGrouping.length - 1 && groupingIndex === -1) return;

    var sortIndex = dxGridCore.adjustSortIndex(groupingIndex === -1 ? grouping.length : groupingIndex, grouping, sorting);

    if (columnSortingIndex === sortIndex) return;

    changeColumnSorting(_extends({
      keepOther: true,
      sortIndex: sortIndex
    }, sorting[columnSortingIndex]));
  };

  var columnExtensionValueGetter$1 = function columnExtensionValueGetter(columnExtensions, defaultValue) {
    return dxGridCore.getColumnExtensionValueGetter(columnExtensions, 'groupingEnabled', defaultValue);
  };

  var DxGroupingState = {
    name: 'DxGroupingState',
    props: {
      grouping: {
        type: Array,
        required: true
      },
      expandedGroups: {
        type: Array,
        required: true
      },
      columnExtensions: {
        type: Array,
        default: function _default() {
          return [];
        }
      },
      columnGroupingEnabled: {
        type: Boolean,
        default: true
      }
    },
    methods: {
      changeColumnSorting: function changeColumnSorting(_ref5, _ref6, _ref7) {
        var sorting = _ref6.sorting;
        var changeColumnSorting = _ref7.changeColumnSorting;
        var columnName = _ref5.columnName,
            keepOther = _ref5.keepOther,
            restParams = objectWithoutProperties(_ref5, ['columnName', 'keepOther']);
        var grouping = this.grouping;

        var groupingIndex = grouping.findIndex(function (columnGrouping) {
          return columnGrouping.columnName === columnName;
        });
        if (groupingIndex === -1) {
          changeColumnSorting(_extends({
            columnName: columnName,
            keepOther: keepOther || grouping.map(function (columnGrouping) {
              return columnGrouping.columnName;
            })
          }, restParams));
          return false;
        }

        var sortIndex = dxGridCore.adjustSortIndex(groupingIndex, grouping, sorting);
        changeColumnSorting(_extends({
          columnName: columnName,
          keepOther: true,
          sortIndex: sortIndex
        }, restParams));
        return false;
      },
      changeColumnGrouping: function changeColumnGrouping(_ref8, getters, actions) {
        var columnName = _ref8.columnName,
            groupingIndex = _ref8.groupingIndex;

        var prevState = {
          grouping: this.grouping,
          expandedGroups: this.expandedGroups
        };
        var stateChange = dxGridCore.changeColumnGrouping(prevState, { columnName: columnName, groupingIndex: groupingIndex });

        this.$emit('update:grouping', stateChange.grouping);

        callback(_extends({}, prevState, stateChange), prevState, getters, actions, columnName);
      },
      toggleGroupExpanded: function toggleGroupExpanded(_ref9) {
        var groupKey = _ref9.groupKey;

        this.$emit('update:expandedGroups', dxGridCore.toggleExpandedGroups({ expandedGroups: this.expandedGroups }, { groupKey: groupKey }).expandedGroups);
      }
    },
    render: function render() {
      var h = arguments[0];
      var grouping = this.grouping,
          expandedGroups = this.expandedGroups;
      var columnExtensions = this.columnExtensions,
          columnGroupingEnabled = this.columnGroupingEnabled;


      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxGroupingState',
            dependencies: dependencies
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'grouping', value: grouping }
        }), h(dxVueCore.DxGetter, {
          attrs: {
            name: 'isColumnGroupingEnabled',
            value: columnExtensionValueGetter$1(columnExtensions, columnGroupingEnabled)
          }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'changeColumnGrouping', action: this.changeColumnGrouping }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'expandedGroups', value: expandedGroups }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'toggleGroupExpanded', action: this.toggleGroupExpanded }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'changeColumnSorting', action: this.changeColumnSorting }
        })]
      );
    }
  };

  var pluginDependencies$4 = [{ name: 'DxGroupingState' }];

  var getCollapsedRowsComputed$1 = function getCollapsedRowsComputed(_ref) {
    var getCollapsedRows = _ref.getCollapsedRows;
    return dxGridCore.groupCollapsedRowsGetter(getCollapsedRows);
  };

  var expandedGroupedRowsComputed = function expandedGroupedRowsComputed(_ref2) {
    var rows = _ref2.rows,
        grouping = _ref2.grouping,
        expandedGroups = _ref2.expandedGroups;
    return dxGridCore.expandedGroupRows(rows, grouping, expandedGroups);
  };

  var DxIntegratedGrouping = {
    name: 'DxIntegratedGrouping',
    props: {
      columnExtensions: {
        type: Array
      }
    },
    render: function render() {
      var h = arguments[0];
      var columnExtensions = this.columnExtensions;

      var getColumnCriteria = function getColumnCriteria(columnName) {
        return dxGridCore.getColumnExtension(columnExtensions, columnName).criteria;
      };

      var groupedRowsComputed = function groupedRowsComputed(_ref3) {
        var rows = _ref3.rows,
            grouping = _ref3.grouping,
            getCellValue = _ref3.getCellValue;
        return dxGridCore.groupedRows(rows, grouping, getCellValue, getColumnCriteria);
      };

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxIntegratedGrouping',
            dependencies: pluginDependencies$4
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'isGroupRow', value: dxGridCore.groupRowChecker }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'getRowLevelKey', value: dxGridCore.groupRowLevelKeyGetter }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'getCollapsedRows', computed: getCollapsedRowsComputed$1 }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'rows', computed: groupedRowsComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'rows', computed: expandedGroupedRowsComputed }
        })]
      );
    }
  };

  var pluginDependencies$5 = [{ name: 'DxGroupingState' }];

  var getCollapsedRowsComputed$2 = function getCollapsedRowsComputed(_ref) {
    var getCollapsedRows = _ref.getCollapsedRows;
    return dxGridCore.groupCollapsedRowsGetter(getCollapsedRows);
  };
  var expandedGroupedRowsComputed$1 = function expandedGroupedRowsComputed(_ref2) {
    var rows = _ref2.rows,
        grouping = _ref2.grouping,
        expandedGroups = _ref2.expandedGroups;
    return dxGridCore.expandedGroupRows(rows, grouping, expandedGroups);
  };
  var getRowIdComputed = function getRowIdComputed(_ref3) {
    var getRowId = _ref3.getRowId,
        rows = _ref3.rows;
    return dxGridCore.customGroupingRowIdGetter(getRowId, rows);
  };

  var DxCustomGrouping = {
    name: 'DxCustomGrouping',
    props: {
      getChildGroups: {
        type: Function,
        required: true
      },
      grouping: {
        type: Array
      },
      expandedGroups: {
        type: Array
      }
    },
    render: function render() {
      var h = arguments[0];
      var getChildGroups = this.getChildGroups,
          appliedGrouping = this.grouping,
          appliedExpandedGroups = this.expandedGroups;

      var groupedRowsComputed = function groupedRowsComputed(_ref4) {
        var rows = _ref4.rows,
            grouping = _ref4.grouping;
        return dxGridCore.customGroupedRows(rows, grouping, getChildGroups);
      };
      var groupingComputed = function groupingComputed(_ref5) {
        var grouping = _ref5.grouping;
        return appliedGrouping || grouping;
      };
      var expandedGroupsComputed = function expandedGroupsComputed(_ref6) {
        var expandedGroups = _ref6.expandedGroups;
        return appliedExpandedGroups || expandedGroups;
      };

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxCustomGrouping',
            dependencies: pluginDependencies$5
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'grouping', computed: groupingComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'expandedGroups', computed: expandedGroupsComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'isGroupRow', value: dxGridCore.groupRowChecker }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'getRowLevelKey', value: dxGridCore.groupRowLevelKeyGetter }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'getCollapsedRows', computed: getCollapsedRowsComputed$2 }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'rows', computed: groupedRowsComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'getRowId', computed: getRowIdComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'rows', computed: expandedGroupedRowsComputed$1 }
        })]
      );
    }
  };

  var DxGroupingPanel = {
    props: {
      showSortingControls: {
        type: Boolean
      },
      showGroupingControls: {
        type: Boolean
      },
      messages: {
        type: Object
      },
      layoutComponent: {
        type: Object,
        required: true
      },
      containerComponent: {
        type: Object,
        required: true
      },
      itemComponent: {
        type: Object,
        required: true
      },
      emptyMessageComponent: {
        type: Object,
        required: true
      }
    },
    render: function render() {
      var h = arguments[0];
      var Layout = this.layoutComponent,
          Container = this.containerComponent,
          Item = this.itemComponent,
          EmptyMessage = this.emptyMessageComponent,
          showSortingControls = this.showSortingControls,
          showGroupingControls = this.showGroupingControls,
          messages = this.messages;


      var getMessage = dxCore.getMessagesFormatter(messages);

      var EmptyMessagePlaceholder = {
        render: function render() {
          var h = arguments[0];

          return h(EmptyMessage, {
            attrs: {
              getMessage: getMessage
            }
          });
        }
      };

      var ItemPlaceholder = {
        props: {
          item: {
            type: Object,
            required: true
          }
        },
        render: function render() {
          var _this = this;

          var h = arguments[0];
          var columnName = this.item.column.name;


          return h(dxVueCore.DxTemplateConnector, [function (_ref) {
            var _ref$getters = _ref.getters,
                sorting = _ref$getters.sorting,
                isColumnSortingEnabled = _ref$getters.isColumnSortingEnabled,
                isColumnGroupingEnabled = _ref$getters.isColumnGroupingEnabled,
                _ref$actions = _ref.actions,
                changeColumnGrouping = _ref$actions.changeColumnGrouping,
                changeColumnSorting = _ref$actions.changeColumnSorting;

            var sortingEnabled = isColumnSortingEnabled && isColumnSortingEnabled(columnName);
            var groupingEnabled = isColumnGroupingEnabled && isColumnGroupingEnabled(columnName);

            return h(Item, {
              attrs: {
                item: _this.item,
                sortingEnabled: sortingEnabled,
                groupingEnabled: groupingEnabled,
                showSortingControls: showSortingControls,
                sortingDirection: showSortingControls ? dxGridCore.getColumnSortingDirection(sorting, columnName) : undefined,
                showGroupingControls: showGroupingControls
              },
              on: {
                'group': function group() {
                  return changeColumnGrouping({ columnName: columnName });
                },
                'sort': function sort(_ref2) {
                  var direction = _ref2.direction,
                      keepOther = _ref2.keepOther;
                  return changeColumnSorting({ columnName: columnName, direction: direction, keepOther: keepOther });
                }
              }
            });
          }]);
        }
      };

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxGroupingPanel',
            dependencies: [{ name: 'DxGroupingState' }, { name: 'DxToolbar' }, { name: 'DxSortingState', optional: !showSortingControls }]
          }
        },
        [h(
          dxVueCore.DxTemplate,
          {
            attrs: { name: 'toolbarContent' }
          },
          [h(
            'div',
            { style: { display: 'flex', flex: 1 } },
            [h(dxVueCore.DxTemplateConnector, [function (_ref3) {
              var _ref3$getters = _ref3.getters,
                  columns = _ref3$getters.columns,
                  grouping = _ref3$getters.grouping,
                  isColumnGroupingEnabled = _ref3$getters.isColumnGroupingEnabled,
                  changeColumnGrouping = _ref3.actions.changeColumnGrouping;
              return h(Layout, {
                attrs: {
                  items: dxGridCore.groupingPanelItems(columns, grouping, []),
                  isColumnGroupingEnabled: isColumnGroupingEnabled,

                  itemComponent: ItemPlaceholder,
                  emptyMessageComponent: EmptyMessagePlaceholder,
                  containerComponent: Container
                },
                on: {
                  'group': changeColumnGrouping
                }
              });
            }]), h(dxVueCore.DxTemplatePlaceholder)]
          )]
        )]
      );
    }
  };

  var pluginDependencies$6 = [{ name: 'DxGroupingState' }, { name: 'DxTable' }, { name: 'DxDataTypeProvider', optional: true }];

  var tableBodyRowsComputed$1 = function tableBodyRowsComputed(_ref) {
    var tableBodyRows = _ref.tableBodyRows,
        isGroupRow = _ref.isGroupRow;
    return dxGridCore.tableRowsWithGrouping(tableBodyRows, isGroupRow);
  };
  var getCellColSpanComputed = function getCellColSpanComputed(_ref2) {
    var getTableCellColSpan = _ref2.getTableCellColSpan;
    return dxGridCore.tableGroupCellColSpanGetter(getTableCellColSpan);
  };

  var showColumnWhenGroupedGetter = function showColumnWhenGroupedGetter(showColumnsWhenGrouped) {
    var columnExtensions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

    var map = columnExtensions.reduce(function (acc, columnExtension) {
      acc[columnExtension.columnName] = columnExtension.showWhenGrouped;
      return acc;
    }, {});

    return function (columnName) {
      return map[columnName] || showColumnsWhenGrouped;
    };
  };

  var DxTableGroupRow = {
    name: 'DxTableGroupRow',
    props: {
      cellComponent: {
        type: Object,
        required: true
      },
      rowComponent: {
        type: Object,
        required: true
      },
      indentCellComponent: {
        type: Object
      },
      indentColumnWidth: {
        type: Number,
        required: true
      },
      showColumnsWhenGrouped: {
        type: Boolean
      },
      columnExtensions: {
        type: Array
      }
    },
    render: function render() {
      var h = arguments[0];
      var GroupCell = this.cellComponent,
          GroupRow = this.rowComponent,
          GroupIndentCell = this.indentCellComponent,
          indentColumnWidth = this.indentColumnWidth,
          showColumnsWhenGrouped = this.showColumnsWhenGrouped,
          columnExtensions = this.columnExtensions;


      var tableColumnsComputed = function tableColumnsComputed(_ref3) {
        var columns = _ref3.columns,
            tableColumns = _ref3.tableColumns,
            grouping = _ref3.grouping;
        return dxGridCore.tableColumnsWithGrouping(columns, tableColumns, grouping, grouping, indentColumnWidth, showColumnWhenGroupedGetter(showColumnsWhenGrouped, columnExtensions));
      };
      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxTableGroupRow',
            dependencies: pluginDependencies$6
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'tableColumns', computed: tableColumnsComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'tableBodyRows', computed: tableBodyRowsComputed$1 }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'getTableCellColSpan', computed: getCellColSpanComputed }
        }), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableCell',
              predicate: function predicate(_ref4) {
                var tableRow = _ref4.attrs.tableRow;
                return dxGridCore.isGroupTableRow(tableRow);
              }
            }
          },
          [function (_ref5) {
            var attrs = _ref5.attrs,
                listeners = _ref5.listeners;
            return h(dxVueCore.DxTemplateConnector, [function (_ref6) {
              var _ref6$getters = _ref6.getters,
                  grouping = _ref6$getters.grouping,
                  expandedGroups = _ref6$getters.expandedGroups,
                  toggleGroupExpanded = _ref6.actions.toggleGroupExpanded;

              if (dxGridCore.isGroupTableCell(attrs.tableRow, attrs.tableColumn)) {
                return h(
                  dxVueCore.DxTemplatePlaceholder,
                  {
                    attrs: {
                      name: 'valueFormatter',
                      column: attrs.tableColumn.column,
                      value: attrs.tableRow.row.value
                    }
                  },
                  [function (content) {
                    return h(
                      GroupCell,
                      babelHelperVueJsxMergeProps([{ attrs: _extends({}, attrs), on: _extends({}, listeners) }, {
                        attrs: {
                          row: attrs.tableRow.row,
                          column: attrs.tableColumn.column,
                          expanded: expandedGroups.indexOf(attrs.tableRow.row.compoundKey) !== -1
                        },
                        on: {
                          'toggle': function toggle() {
                            return toggleGroupExpanded({ groupKey: attrs.tableRow.row.compoundKey });
                          }
                        }
                      }]),
                      [content]
                    );
                  }]
                );
              }
              if (dxGridCore.isGroupIndentTableCell(attrs.tableRow, attrs.tableColumn, grouping)) {
                if (GroupIndentCell) {
                  return h(GroupIndentCell, babelHelperVueJsxMergeProps([{ attrs: _extends({}, attrs), on: _extends({}, listeners) }, {
                    attrs: {
                      row: attrs.tableRow.row,
                      column: attrs.tableColumn.column
                    }
                  }]));
                }
                return h(dxVueCore.DxTemplatePlaceholder);
              }
              return null;
            }]);
          }]
        ), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableRow',
              predicate: function predicate(_ref7) {
                var tableRow = _ref7.attrs.tableRow;
                return dxGridCore.isGroupTableRow(tableRow);
              }
            }
          },
          [function (_ref8) {
            var attrs = _ref8.attrs,
                listeners = _ref8.listeners,
                slots = _ref8.slots;
            return h(
              GroupRow,
              babelHelperVueJsxMergeProps([{ attrs: _extends({}, attrs), on: _extends({}, listeners) }, {
                attrs: {
                  row: attrs.tableRow.row
                }
              }]),
              [slots.default]
            );
          }]
        )]
      );
    }
  };

  var ItemLayout = {
    props: {
      item: {
        type: Object,
        required: true
      },
      itemComponent: {
        type: Object,
        required: true
      }
    },
    render: function render() {
      var h = arguments[0];
      var item = this.item,
          Item = this.itemComponent;

      return h(Item, {
        attrs: { item: _extends({}, item) }
      });
    }
  };

  var GroupPanelLayout = {
    props: {
      items: {
        type: Array,
        required: true
      },
      itemComponent: {
        type: Object,
        required: true
      },
      containerComponent: {
        type: Object,
        required: true
      },
      emptyMessageComponent: {
        type: Object,
        required: true
      }
    },
    render: function render() {
      var h = arguments[0];
      var items = this.items,
          EmptyMessage = this.emptyMessageComponent,
          Container = this.containerComponent,
          Item = this.itemComponent;


      var groupPanel = items.length ? h(Container, [items.map(function (item) {
        var columnName = item.column.name;

        return h(ItemLayout, {
          key: columnName,
          attrs: { item: item,
            itemComponent: Item
          }
        });
      })]) : h(EmptyMessage);

      return groupPanel;
    }
  };

  var DxSearchState = {
    name: 'DxSearchState',
    props: {
      value: {
        type: String,
        required: true
      }
    },
    methods: {
      changeValue: function changeValue(payload) {
        this.$emit('update:value', dxGridCore.changeSearchValue(this.value, payload));
      }
    },
    render: function render() {
      var h = arguments[0];
      var value = this.value,
          changeValue = this.changeValue;

      var filterExpressionComputed = function filterExpressionComputed(_ref) {
        var filterExpression = _ref.filterExpression,
            columns = _ref.columns;
        return dxGridCore.searchFilterExpression(value, columns, filterExpression);
      };

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxSearchState'
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'filterExpression', computed: filterExpressionComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'searchValue', value: value }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'changeSearchValue', action: changeValue }
        })]
      );
    }
  };

  var pluginDependencies$7 = [{ name: 'DxToolbar' }, { name: 'DxSearchState' }];

  var DxSearchPanel = {
    name: 'DxSearchPanel',
    props: {
      inputComponent: {
        type: Object,
        required: true
      },
      messages: {
        type: Object,
        default: function _default() {
          return {};
        }
      }
    },
    render: function render() {
      var h = arguments[0];
      var Input = this.inputComponent,
          messages = this.messages;

      var getMessage = dxCore.getMessagesFormatter(messages);

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxSearchPanel',
            dependencies: pluginDependencies$7
          }
        },
        [h(
          dxVueCore.DxTemplate,
          {
            attrs: { name: 'toolbarContent' }
          },
          [h(
            'div',
            { style: { display: 'flex', flex: 1 } },
            [h(dxVueCore.DxTemplatePlaceholder), h(dxVueCore.DxTemplateConnector, [function (_ref) {
              var searchValue = _ref.getters.searchValue,
                  changeSearchValue = _ref.actions.changeSearchValue;
              return h(Input, {
                attrs: {
                  value: searchValue,

                  getMessage: getMessage
                },
                on: {
                  'valueChange': changeSearchValue
                }
              });
            }])]
          )]
        )]
      );
    }
  };

  var DxSelectionState = {
    name: 'DxSelectionState',
    props: {
      selection: {
        type: Array,
        required: true
      }
    },
    methods: {
      toggleSelection: function toggleSelection(payload) {
        this.$emit('update:selection', dxGridCore.toggleSelection(this.selection, payload));
      }
    },
    render: function render() {
      var h = arguments[0];

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxSelectionState'
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'selection', value: this.selection }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'toggleSelection', action: this.toggleSelection }
        })]
      );
    }
  };

  var rowsWithAvailableToSelectComputed = function rowsWithAvailableToSelectComputed(_ref) {
    var rows = _ref.rows,
        getRowId = _ref.getRowId,
        isGroupRow = _ref.isGroupRow;
    return dxGridCore.rowsWithAvailableToSelect(rows, getRowId, isGroupRow);
  };
  var allSelectedComputed = function allSelectedComputed(_ref2) {
    var rows = _ref2.rows,
        selection = _ref2.selection;
    return dxGridCore.allSelected(rows, selection);
  };
  var someSelectedComputed = function someSelectedComputed(_ref3) {
    var rows = _ref3.rows,
        selection = _ref3.selection;
    return dxGridCore.someSelected(rows, selection);
  };
  var selectAllAvailableComputed = function selectAllAvailableComputed(_ref4) {
    var availableToSelect = _ref4.rows.availableToSelect;
    return !!availableToSelect.length;
  };
  var toggleSelectAll = function toggleSelectAll(state, _ref5, _ref6) {
    var availableToSelect = _ref5.rows.availableToSelect;
    var toggleSelection = _ref6.toggleSelection;

    toggleSelection({ rowIds: availableToSelect, state: state });
  };
  var unwrapRowsComputed = function unwrapRowsComputed(_ref7) {
    var rows = _ref7.rows;
    return dxGridCore.unwrapSelectedRows(rows);
  };

  var pluginDependencies$8 = [{ name: 'DxSelectionState' }];

  var DxIntegratedSelection = {
    name: 'DxIntegratedSelection',
    render: function render() {
      var h = arguments[0];

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxIntegratedSelection',
            dependencies: pluginDependencies$8
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'rows', computed: rowsWithAvailableToSelectComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'allSelected', computed: allSelectedComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'someSelected', computed: someSelectedComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'selectAllAvailable', computed: selectAllAvailableComputed }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'toggleSelectAll', action: toggleSelectAll }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'rows', computed: unwrapRowsComputed }
        })]
      );
    }
  };

  var DxTableSelection = {
    name: 'DxTableSelection',
    props: {
      highlightRow: {
        type: Boolean
      },
      selectByRowClick: {
        type: Boolean
      },
      showSelectionColumn: {
        type: Boolean,
        default: true
      },
      showSelectAll: {
        type: Boolean
      },
      selectionColumnWidth: {
        type: Number,
        required: true
      },
      rowComponent: {
        type: Object,
        required: true
      },
      cellComponent: {
        type: Object,
        required: true
      },
      headerCellComponent: {
        type: Object,
        required: true
      }
    },
    render: function render() {
      var h = arguments[0];
      var highlightRow = this.highlightRow,
          selectByRowClick = this.selectByRowClick,
          showSelectionColumn = this.showSelectionColumn,
          showSelectAll = this.showSelectAll,
          HeaderCell = this.headerCellComponent,
          Cell = this.cellComponent,
          Row = this.rowComponent,
          selectionColumnWidth = this.selectionColumnWidth;


      var tableColumnsComputed = function tableColumnsComputed(_ref) {
        var tableColumns = _ref.tableColumns;
        return dxGridCore.tableColumnsWithSelection(tableColumns, selectionColumnWidth);
      };

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxTableSelection',
            dependencies: [{ name: 'DxTable' }, { name: 'DxSelectionState' }, { name: 'DxIntegratedSelection', optional: !showSelectAll }]
          }
        },
        [showSelectionColumn && h(dxVueCore.DxGetter, {
          attrs: { name: 'tableColumns', computed: tableColumnsComputed }
        }), showSelectionColumn && showSelectAll && h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableCell',
              predicate: function predicate(_ref2) {
                var _ref2$attrs = _ref2.attrs,
                    tableRow = _ref2$attrs.tableRow,
                    tableColumn = _ref2$attrs.tableColumn;
                return dxGridCore.isSelectAllTableCell(tableRow, tableColumn);
              }
            }
          },
          [function (_ref3) {
            var attrs = _ref3.attrs,
                listeners = _ref3.listeners;
            return h(dxVueCore.DxTemplateConnector, [function (_ref4) {
              var _ref4$getters = _ref4.getters,
                  selectAllAvailable = _ref4$getters.selectAllAvailable,
                  allSelected = _ref4$getters.allSelected,
                  someSelected = _ref4$getters.someSelected,
                  toggleSelectAll = _ref4.actions.toggleSelectAll;
              return h(HeaderCell, babelHelperVueJsxMergeProps([{ attrs: _extends({}, attrs), on: _extends({}, listeners) }, {
                attrs: {
                  disabled: !selectAllAvailable,
                  allSelected: allSelected,
                  someSelected: someSelected
                },
                on: {
                  'toggle': function toggle(select) {
                    return toggleSelectAll(select);
                  }
                }
              }]));
            }]);
          }]
        ), showSelectionColumn && h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableCell',
              predicate: function predicate(_ref5) {
                var _ref5$attrs = _ref5.attrs,
                    tableRow = _ref5$attrs.tableRow,
                    tableColumn = _ref5$attrs.tableColumn;
                return dxGridCore.isSelectTableCell(tableRow, tableColumn);
              }
            }
          },
          [function (_ref6) {
            var attrs = _ref6.attrs,
                listeners = _ref6.listeners;
            return h(dxVueCore.DxTemplateConnector, [function (_ref7) {
              var selection = _ref7.getters.selection,
                  toggleSelection = _ref7.actions.toggleSelection;
              return h(Cell, babelHelperVueJsxMergeProps([{ attrs: _extends({}, attrs), on: _extends({}, listeners) }, {
                attrs: {
                  row: attrs.tableRow.row,
                  selected: selection.indexOf(attrs.tableRow.rowId) !== -1
                },
                on: {
                  'toggle': function toggle() {
                    return toggleSelection({ rowIds: [attrs.tableRow.rowId] });
                  }
                }
              }]));
            }]);
          }]
        ), (highlightRow || selectByRowClick) && h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableRow',
              predicate: function predicate(_ref8) {
                var tableRow = _ref8.attrs.tableRow;
                return dxGridCore.isDataTableRow(tableRow);
              }
            }
          },
          [function (_ref9) {
            var attrs = _ref9.attrs,
                listeners = _ref9.listeners,
                slots = _ref9.slots;
            return h(dxVueCore.DxTemplateConnector, [function (_ref10) {
              var selection = _ref10.getters.selection,
                  toggleSelection = _ref10.actions.toggleSelection;
              return h(
                Row,
                babelHelperVueJsxMergeProps([{ attrs: _extends({}, attrs), on: _extends({}, listeners) }, {
                  attrs: {
                    selectByRowClick: selectByRowClick,
                    selected: highlightRow && selection.indexOf(attrs.tableRow.rowId) !== -1
                  },
                  on: {
                    'toggle': function toggle() {
                      return toggleSelection({ rowIds: [attrs.tableRow.rowId] });
                    }
                  }
                }]),
                [slots.default]
              );
            }]);
          }]
        )]
      );
    }
  };

  var DxPagingState = {
    name: 'DxPagingState',
    props: {
      currentPage: {
        type: Number,
        required: true
      },
      pageSize: {
        type: Number,
        default: 10
      }
    },
    methods: {
      setCurrentPage: function setCurrentPage(payload) {
        this.$emit('update:currentPage', dxGridCore.setCurrentPage(this.currentPage, payload));
      },
      setPageSize: function setPageSize(payload) {
        this.$emit('update:pageSize', dxGridCore.setPageSize(this.pageSize, payload));
      }
    },
    render: function render() {
      var h = arguments[0];
      var pageSize = this.pageSize,
          currentPage = this.currentPage;


      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxPagingState'
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'pageSize', value: pageSize }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'currentPage', value: currentPage }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'setCurrentPage', action: this.setCurrentPage }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'setPageSize', action: this.setPageSize }
        })]
      );
    }
  };

  var pluginDependencies$9 = [{ name: 'DxPagingState' }];

  var rowsWithHeadersComputed = function rowsWithHeadersComputed(_ref) {
    var rows = _ref.rows,
        pageSize = _ref.pageSize,
        getRowLevelKey = _ref.getRowLevelKey;
    return dxGridCore.rowsWithPageHeaders(rows, pageSize, getRowLevelKey);
  };
  var totalCountComputed = function totalCountComputed(_ref2) {
    var rows = _ref2.rows;
    return dxGridCore.rowCount(rows);
  };
  var paginatedRowsComputed = function paginatedRowsComputed(_ref3) {
    var rows = _ref3.rows,
        pageSize = _ref3.pageSize,
        page = _ref3.currentPage;
    return dxGridCore.paginatedRows(rows, pageSize, page);
  };
  var currentPageComputed = function currentPageComputed(_ref4, _ref5) {
    var page = _ref4.currentPage,
        totalCount = _ref4.totalCount,
        pageSize = _ref4.pageSize;
    var setCurrentPage = _ref5.setCurrentPage;
    return dxGridCore.currentPage(page, totalCount, pageSize, setCurrentPage);
  };

  var DxIntegratedPaging = {
    name: 'DxIntegratedPaging',
    render: function render() {
      var h = arguments[0];

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxIntegratedPaging',
            dependencies: pluginDependencies$9
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'rows', computed: rowsWithHeadersComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'totalCount', computed: totalCountComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'currentPage', computed: currentPageComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'rows', computed: paginatedRowsComputed }
        })]
      );
    }
  };

  var pluginDependencies$a = [{ name: 'DxPagingState' }];

  var DxCustomPaging = {
    name: 'DxCustomPaging',
    props: {
      totalCount: {
        type: Number,
        default: 0
      }
    },

    render: function render() {
      var h = arguments[0];
      var totalCount = this.totalCount;


      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxCustomPaging',
            dependencies: pluginDependencies$a
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'totalCount', value: totalCount }
        })]
      );
    }
  };

  var pluginDependencies$b = [{ name: 'DxPagingState' }];

  var DxPagingPanel = {
    name: 'DxPagingPanel',
    props: {
      pageSizes: {
        type: Array,
        default: function _default() {
          return [];
        }
      },
      messages: {
        type: Object
      },
      containerComponent: {
        type: Object,
        required: true
      }
    },

    render: function render() {
      var h = arguments[0];
      var Pager = this.containerComponent,
          pageSizes = this.pageSizes,
          messages = this.messages;

      var getMessage = dxCore.getMessagesFormatter(messages);

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxPagingPanel',
            dependencies: pluginDependencies$b
          }
        },
        [h(
          dxVueCore.DxTemplate,
          {
            attrs: { name: 'footer' }
          },
          [h('div', [' ', h(dxVueCore.DxTemplatePlaceholder), h(dxVueCore.DxTemplateConnector, [function (_ref) {
            var _ref$getters = _ref.getters,
                currentPage = _ref$getters.currentPage,
                pageSize = _ref$getters.pageSize,
                totalCount = _ref$getters.totalCount,
                _ref$actions = _ref.actions,
                setCurrentPage = _ref$actions.setCurrentPage,
                setPageSize = _ref$actions.setPageSize;
            return h(Pager, {
              attrs: {
                currentPage: currentPage,
                pageSize: pageSize,
                totalCount: totalCount,
                totalPages: dxGridCore.pageCount(totalCount, pageSize),
                pageSizes: pageSizes,
                getMessage: getMessage
              },
              on: {
                'currentPageChange': setCurrentPage,
                'pageSizeChange': setPageSize
              }
            });
          }])])]
        )]
      );
    }
  };

  var DxDataTypeProvider = {
    name: 'DxDataTypeProvider',
    props: {
      for: {
        type: Array,
        required: true
      },
      formatterComponent: {
        type: Object
      },
      editorComponent: {
        type: Object
      },
      availableFilterOperations: {
        type: Array
      }
    },
    render: function render() {
      var h = arguments[0];
      var columnNames = this.for,
          Formatter = this.formatterComponent,
          Editor = this.editorComponent,
          availableFilterOperations = this.availableFilterOperations;


      var getAvailableFilterOperationsComputed = function getAvailableFilterOperationsComputed(_ref) {
        var getAvailableFilterOperations = _ref.getAvailableFilterOperations;
        return dxGridCore.getAvailableFilterOperationsGetter(getAvailableFilterOperations, availableFilterOperations, columnNames);
      };

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: { name: 'DxDataTypeProvider' }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'getAvailableFilterOperations', computed: getAvailableFilterOperationsComputed }
        }), Formatter ? h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'valueFormatter',
              predicate: function predicate(_ref2) {
                var column = _ref2.attrs.column;
                return columnNames.includes(column.name);
              }
            }
          },
          [function (_ref3) {
            var attrs = _ref3.attrs;
            return h(Formatter, { attrs: attrs });
          }]
        ) : null, Editor ? h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'valueEditor',
              predicate: function predicate(_ref4) {
                var column = _ref4.attrs.column;
                return columnNames.includes(column.name);
              }
            }
          },
          [function (_ref5) {
            var attrs = _ref5.attrs,
                listeners = _ref5.listeners;
            return h(Editor, { attrs: _extends({}, attrs), on: _extends({}, listeners) });
          }]
        ) : null]
      );
    }
  };

  var DxRowDetailState = {
    name: 'DxRowDetailState',
    props: {
      expandedRowIds: {
        type: Array,
        required: true
      }
    },
    methods: {
      toggleDetailRowExpanded: function toggleDetailRowExpanded(payload) {
        this.$emit('update:expandedRowIds', dxGridCore.toggleDetailRowExpanded(this.expandedRowIds, payload));
      }
    },
    render: function render() {
      var h = arguments[0];

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxRowDetailState'
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'expandedDetailRowIds', value: this.expandedRowIds }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'toggleDetailRowExpanded', action: this.toggleDetailRowExpanded }
        })]
      );
    }
  };

  var getCellColSpanComputed$1 = function getCellColSpanComputed(_ref) {
    var getTableCellColSpan = _ref.getTableCellColSpan;
    return dxGridCore.tableDetailCellColSpanGetter(getTableCellColSpan);
  };

  var pluginDependencies$c = [{ name: 'DxRowDetailState' }, { name: 'DxTable' }];

  var DxTableRowDetail = {
    name: 'DxTableRowDetail',
    props: {
      contentComponent: {
        type: Object
      },
      toggleCellComponent: {
        type: Object,
        required: true
      },
      cellComponent: {
        type: Object,
        required: true
      },
      rowComponent: {
        type: Object,
        required: true
      },
      toggleColumnWidth: {
        type: Number,
        required: true
      },
      rowHeight: {
        type: Number
      }
    },
    render: function render() {
      var h = arguments[0];
      var rowHeight = this.rowHeight,
          Content = this.contentComponent,
          ToggleCell = this.toggleCellComponent,
          Cell = this.cellComponent,
          Row = this.rowComponent,
          toggleColumnWidth = this.toggleColumnWidth;


      var tableColumnsComputed = function tableColumnsComputed(_ref2) {
        var tableColumns = _ref2.tableColumns;
        return dxGridCore.tableColumnsWithDetail(tableColumns, toggleColumnWidth);
      };
      var tableBodyRowsComputed = function tableBodyRowsComputed(_ref3) {
        var tableBodyRows = _ref3.tableBodyRows,
            expandedDetailRowIds = _ref3.expandedDetailRowIds;
        return dxGridCore.tableRowsWithExpandedDetail(tableBodyRows, expandedDetailRowIds, rowHeight);
      };

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxTableRowDetail',
            dependencies: pluginDependencies$c
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'tableColumns', computed: tableColumnsComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'tableBodyRows', computed: tableBodyRowsComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'getTableCellColSpan', computed: getCellColSpanComputed$1 }
        }), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableCell',
              predicate: function predicate(_ref4) {
                var _ref4$attrs = _ref4.attrs,
                    tableRow = _ref4$attrs.tableRow,
                    tableColumn = _ref4$attrs.tableColumn;
                return dxGridCore.isDetailToggleTableCell(tableRow, tableColumn);
              }
            }
          },
          [function (_ref5) {
            var attrs = _ref5.attrs,
                listeners = _ref5.listeners;
            return h(dxVueCore.DxTemplateConnector, [function (_ref6) {
              var expandedDetailRowIds = _ref6.getters.expandedDetailRowIds,
                  toggleDetailRowExpanded = _ref6.actions.toggleDetailRowExpanded;
              return h(ToggleCell, babelHelperVueJsxMergeProps([{ attrs: _extends({}, attrs), on: _extends({}, listeners) }, {
                attrs: {
                  row: attrs.tableRow.row,
                  expanded: dxGridCore.isDetailRowExpanded(expandedDetailRowIds, attrs.tableRow.rowId)
                },
                on: {
                  'toggle': function toggle() {
                    return toggleDetailRowExpanded({ rowId: attrs.tableRow.rowId });
                  }
                }
              }]));
            }]);
          }]
        ), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableCell',
              predicate: function predicate(_ref7) {
                var tableRow = _ref7.attrs.tableRow;
                return dxGridCore.isDetailTableRow(tableRow);
              }
            }
          },
          [function (_ref8) {
            var attrs = _ref8.attrs,
                listeners = _ref8.listeners;
            return h(dxVueCore.DxTemplateConnector, [function (_ref9) {
              var tableColumns = _ref9.getters.tableColumns;

              if (dxGridCore.isDetailTableCell(attrs.tableColumn, tableColumns)) {
                return h(
                  Cell,
                  babelHelperVueJsxMergeProps([{ attrs: _extends({}, attrs), on: _extends({}, listeners) }, {
                    attrs: {
                      row: attrs.tableRow.row
                    }
                  }]),
                  [h(Content, {
                    attrs: { row: attrs.tableRow.row }
                  })]
                );
              }
              return null;
            }]);
          }]
        ), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableRow',
              predicate: function predicate(_ref10) {
                var tableRow = _ref10.attrs.tableRow;
                return dxGridCore.isDetailTableRow(tableRow);
              }
            }
          },
          [function (_ref11) {
            var attrs = _ref11.attrs,
                listeners = _ref11.listeners,
                slots = _ref11.slots;
            return h(
              Row,
              babelHelperVueJsxMergeProps([{ attrs: _extends({}, attrs), on: _extends({}, listeners) }, {
                attrs: {
                  row: attrs.tableRow.row
                }
              }]),
              [slots.default]
            );
          }]
        )]
      );
    }
  };

  var columnExtensionValueGetter$2 = function columnExtensionValueGetter(columnExtensions, defaultValue) {
    return dxGridCore.getColumnExtensionValueGetter(columnExtensions, 'editingEnabled', defaultValue);
  };

  var DxEditingState = {
    name: 'DxEditingState',
    props: {
      createRowChange: {
        type: Function
      },
      columnEditingEnabled: {
        type: Boolean,
        default: true
      },
      columnExtensions: {
        type: Array
      },
      editingRowIds: {
        type: Array,
        default: function _default() {
          return [];
        }
      },
      addedRows: {
        type: Array,
        default: function _default() {
          return [];
        }
      },
      rowChanges: {
        type: Object,
        default: function _default() {
          return {};
        }
      },
      deletedRowIds: {
        type: Array,
        default: function _default() {
          return [];
        }
      }
    },
    methods: {
      startEditRows: function startEditRows(payload) {
        this.$emit('update:editingRowIds', dxGridCore.startEditRows(this.editingRowIds, payload));
      },
      stopEditRows: function stopEditRows(payload) {
        this.$emit('update:editingRowIds', dxGridCore.stopEditRows(this.editingRowIds, payload));
      },
      changeRow: function changeRow(payload) {
        this.$emit('update:rowChanges', dxGridCore.changeRow(this.rowChanges, payload));
      },
      cancelChangedRows: function cancelChangedRows(payload) {
        this.$emit('update:rowChanges', dxGridCore.cancelChanges(this.rowChanges, payload));
      },
      commitChangedRows: function commitChangedRows(_ref) {
        var rowIds = _ref.rowIds;

        this.$emit('commitChanges', { changed: dxGridCore.changedRowsByIds(this.rowChanges, rowIds) });
        this.cancelChangedRows({ rowIds: rowIds });
      },
      addRow: function addRow(payload) {
        this.$emit('update:addedRows', dxGridCore.addRow(this.addedRows, payload));
      },
      changeAddedRow: function changeAddedRow(payload) {
        this.$emit('update:addedRows', dxGridCore.changeAddedRow(this.addedRows, payload));
      },
      cancelAddedRows: function cancelAddedRows(payload) {
        this.$emit('update:addedRows', dxGridCore.cancelAddedRows(this.addedRows, payload));
      },
      commitAddedRows: function commitAddedRows(_ref2) {
        var rowIds = _ref2.rowIds;

        this.$emit('commitChanges', { added: dxGridCore.addedRowsByIds(this.addedRows, rowIds) });
        this.cancelAddedRows({ rowIds: rowIds });
      },
      deleteRows: function deleteRows(payload) {
        this.$emit('update:deletedRowIds', dxGridCore.deleteRows(this.deletedRowIds, payload));
      },
      cancelDeletedRows: function cancelDeletedRows(payload) {
        this.$emit('update:deletedRowIds', dxGridCore.cancelDeletedRows(this.deletedRowIds, payload));
      },
      commitDeletedRows: function commitDeletedRows(_ref3) {
        var rowIds = _ref3.rowIds;

        this.$emit('commitChanges', { deleted: rowIds });
        this.cancelDeletedRows({ rowIds: rowIds });
      }
    },
    render: function render() {
      var h = arguments[0];
      var createRowChange = this.createRowChange,
          columnExtensions = this.columnExtensions,
          columnEditingEnabled = this.columnEditingEnabled,
          editingRowIds = this.editingRowIds,
          rowChanges = this.rowChanges,
          addedRows = this.addedRows,
          deletedRowIds = this.deletedRowIds;


      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxEditingState'
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: {
            name: 'createRowChange',
            value: dxGridCore.createRowChangeGetter(createRowChange, columnExtensions)
          }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'editingRowIds', value: editingRowIds }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'startEditRows', action: this.startEditRows }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'stopEditRows', action: this.stopEditRows }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'rowChanges', value: rowChanges }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'changeRow', action: this.changeRow }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'cancelChangedRows', action: this.cancelChangedRows }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'commitChangedRows', action: this.commitChangedRows }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'addedRows', value: addedRows }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'addRow', action: this.addRow }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'changeAddedRow', action: this.changeAddedRow }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'cancelAddedRows', action: this.cancelAddedRows }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'commitAddedRows', action: this.commitAddedRows }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'deletedRowIds', value: deletedRowIds }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'deleteRows', action: this.deleteRows }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'cancelDeletedRows', action: this.cancelDeletedRows }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'commitDeletedRows', action: this.commitDeletedRows }
        }), h(dxVueCore.DxGetter, {
          attrs: {
            name: 'isColumnEditingEnabled',
            value: columnExtensionValueGetter$2(columnExtensions, columnEditingEnabled)
          }
        })]
      );
    }
  };

  var pluginDependencies$d = [{ name: 'DxEditingState' }, { name: 'DxTable' }];

  var DxTableEditColumn = {
    name: 'DxTableEditColumn',
    props: {
      cellComponent: {
        type: Object,
        required: true
      },
      headerCellComponent: {
        type: Object,
        required: true
      },
      commandComponent: {
        type: Object,
        required: true
      },
      showAddCommand: {
        type: Boolean
      },
      showEditCommand: {
        type: Boolean
      },
      showDeleteCommand: {
        type: Boolean
      },
      width: {
        type: Number,
        default: 140
      },
      messages: {
        type: Object,
        default: function _default() {
          return {};
        }
      }
    },
    render: function render() {
      var h = arguments[0];
      var Cell = this.cellComponent,
          HeaderCell = this.headerCellComponent,
          Command = this.commandComponent,
          showAddCommand = this.showAddCommand,
          showEditCommand = this.showEditCommand,
          showDeleteCommand = this.showDeleteCommand,
          width = this.width,
          messages = this.messages;

      var getMessage = dxCore.getMessagesFormatter(messages);
      var tableColumnsComputed = function tableColumnsComputed(_ref) {
        var tableColumns = _ref.tableColumns;
        return dxGridCore.tableColumnsWithEditing(tableColumns, width);
      };

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxTableEditColumn',
            dependencies: pluginDependencies$d
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'tableColumns', computed: tableColumnsComputed }
        }), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableCell',
              predicate: function predicate(_ref2) {
                var _ref2$attrs = _ref2.attrs,
                    tableRow = _ref2$attrs.tableRow,
                    tableColumn = _ref2$attrs.tableColumn;
                return dxGridCore.isHeadingEditCommandsTableCell(tableRow, tableColumn);
              }
            }
          },
          [function (_ref3) {
            var attrs = _ref3.attrs,
                listeners = _ref3.listeners;
            return h(dxVueCore.DxTemplateConnector, [function (_ref4) {
              var addRow = _ref4.actions.addRow;
              return h(
                HeaderCell,
                { attrs: _extends({}, attrs), on: _extends({}, listeners) },
                [showAddCommand && h(Command, {
                  attrs: {
                    id: 'add',
                    text: getMessage('addCommand')
                  },
                  on: {
                    'execute': function execute() {
                      return addRow();
                    }
                  }
                })]
              );
            }]);
          }]
        ), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableCell',
              predicate: function predicate(_ref5) {
                var _ref5$attrs = _ref5.attrs,
                    tableRow = _ref5$attrs.tableRow,
                    tableColumn = _ref5$attrs.tableColumn;
                return dxGridCore.isEditCommandsTableCell(tableRow, tableColumn);
              }
            }
          },
          [function (_ref6) {
            var attrs = _ref6.attrs,
                listeners = _ref6.listeners;
            return h(dxVueCore.DxTemplateConnector, [function (_ref7) {
              var _ref7$actions = _ref7.actions,
                  startEditRows = _ref7$actions.startEditRows,
                  commitDeletedRows = _ref7$actions.commitDeletedRows,
                  commitAddedRows = _ref7$actions.commitAddedRows,
                  commitChangedRows = _ref7$actions.commitChangedRows,
                  deleteRows = _ref7$actions.deleteRows,
                  stopEditRows = _ref7$actions.stopEditRows,
                  cancelAddedRows = _ref7$actions.cancelAddedRows,
                  cancelChangedRows = _ref7$actions.cancelChangedRows;

              var isEdit = dxGridCore.isEditTableRow(attrs.tableRow);
              var isNew = dxGridCore.isAddedTableRow(attrs.tableRow);
              var isEditing = isEdit || isNew;
              var rowIds = [attrs.tableRow.rowId];
              return h(
                Cell,
                babelHelperVueJsxMergeProps([{ attrs: _extends({}, attrs), on: _extends({}, listeners) }, {
                  attrs: {
                    row: attrs.tableRow.row
                  }
                }]),
                [showEditCommand && !isEditing && h(Command, {
                  attrs: {
                    id: 'edit',
                    text: getMessage('editCommand')
                  },
                  on: {
                    'execute': function execute() {
                      return startEditRows({ rowIds: rowIds });
                    }
                  }
                }), showDeleteCommand && !isEditing && h(Command, {
                  attrs: {
                    id: 'delete',
                    text: getMessage('deleteCommand')
                  },
                  on: {
                    'execute': function execute() {
                      deleteRows({ rowIds: rowIds });
                      commitDeletedRows({ rowIds: rowIds });
                    }
                  }
                }), isEditing && h(Command, {
                  attrs: {
                    id: 'commit',
                    text: getMessage('commitCommand')
                  },
                  on: {
                    'execute': function execute() {
                      if (isNew) {
                        commitAddedRows({ rowIds: rowIds });
                      } else {
                        stopEditRows({ rowIds: rowIds });
                        commitChangedRows({ rowIds: rowIds });
                      }
                    }
                  }
                }), isEditing && h(Command, {
                  attrs: {
                    id: 'cancel',
                    text: getMessage('cancelCommand')
                  },
                  on: {
                    'execute': function execute() {
                      if (isNew) {
                        cancelAddedRows({ rowIds: rowIds });
                      } else {
                        stopEditRows({ rowIds: rowIds });
                        cancelChangedRows({ rowIds: rowIds });
                      }
                    }
                  }
                })]
              );
            }]);
          }]
        )]
      );
    }
  };

  var pluginDependencies$e = [{ name: 'DxEditingState' }, { name: 'DxTable' }, { name: 'DxDataTypeProvider', optional: true }];

  var DxTableEditRow = {
    name: 'DxTableEditRow',
    props: {
      rowHeight: {
        type: Number
      },
      cellComponent: {
        type: Object,
        required: true
      },
      rowComponent: {
        type: Object,
        required: true
      }
    },
    render: function render() {
      var h = arguments[0];
      var EditCell = this.cellComponent,
          EditRow = this.rowComponent,
          rowHeight = this.rowHeight;


      var tableBodyRowsComputed = function tableBodyRowsComputed(_ref) {
        var tableBodyRows = _ref.tableBodyRows,
            editingRowIds = _ref.editingRowIds,
            addedRows = _ref.addedRows;
        return dxGridCore.tableRowsWithEditing(tableBodyRows, editingRowIds, addedRows, rowHeight);
      };

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxTableEditRow',
            dependencies: pluginDependencies$e
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'tableBodyRows', computed: tableBodyRowsComputed }
        }), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableCell',
              predicate: function predicate(_ref2) {
                var _ref2$attrs = _ref2.attrs,
                    tableRow = _ref2$attrs.tableRow,
                    tableColumn = _ref2$attrs.tableColumn;
                return dxGridCore.isEditTableCell(tableRow, tableColumn);
              }
            }
          },
          [function (_ref3) {
            var attrs = _ref3.attrs,
                listeners = _ref3.listeners;
            return h(dxVueCore.DxTemplateConnector, [function (_ref4) {
              var _ref4$getters = _ref4.getters,
                  getCellValue = _ref4$getters.getCellValue,
                  createRowChange = _ref4$getters.createRowChange,
                  rowChanges = _ref4$getters.rowChanges,
                  isColumnEditingEnabled = _ref4$getters.isColumnEditingEnabled,
                  _ref4$actions = _ref4.actions,
                  changeAddedRow = _ref4$actions.changeAddedRow,
                  changeRow = _ref4$actions.changeRow;
              var _attrs$tableRow = attrs.tableRow,
                  rowId = _attrs$tableRow.rowId,
                  row = _attrs$tableRow.row;
              var column = attrs.tableColumn.column;
              var columnName = column.name;


              var isNew = dxGridCore.isAddedTableRow(attrs.tableRow);
              var changedRow = isNew ? row : _extends({}, row, dxGridCore.getRowChange(rowChanges, rowId));

              var value = getCellValue(changedRow, columnName);
              var onValueChange = function onValueChange(newValue) {
                var changeArgs = {
                  rowId: rowId,
                  change: createRowChange(changedRow, newValue, columnName)
                };
                if (isNew) {
                  changeAddedRow(changeArgs);
                } else {
                  changeRow(changeArgs);
                }
              };
              return h(
                dxVueCore.DxTemplatePlaceholder,
                {
                  attrs: {
                    name: 'valueEditor',
                    column: column,
                    row: row,
                    value: value
                  },
                  on: {
                    'valueChange': onValueChange
                  }
                },
                [function (content) {
                  return h(
                    EditCell,
                    babelHelperVueJsxMergeProps([{ attrs: _extends({}, attrs), on: _extends({}, listeners) }, {
                      attrs: {
                        row: row,
                        column: column,
                        value: value,
                        editingEnabled: isColumnEditingEnabled(columnName)
                      },
                      on: {
                        'valueChange': onValueChange
                      }
                    }]),
                    [content]
                  );
                }]
              );
            }]);
          }]
        ), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableRow',
              predicate: function predicate(_ref5) {
                var tableRow = _ref5.attrs.tableRow;
                return dxGridCore.isEditTableRow(tableRow) || dxGridCore.isAddedTableRow(tableRow);
              }
            }
          },
          [function (_ref6) {
            var attrs = _ref6.attrs,
                listeners = _ref6.listeners,
                slots = _ref6.slots;
            return h(
              EditRow,
              babelHelperVueJsxMergeProps([{ attrs: _extends({}, attrs), on: _extends({}, listeners) }, {
                attrs: {
                  row: attrs.tableRow.row
                }
              }]),
              [slots.default]
            );
          }]
        )]
      );
    }
  };

  var DxTreeDataState = {
    name: 'DxTreeDataState',
    props: {
      expandedRowIds: {
        type: Array,
        required: true
      }
    },
    methods: {
      toggleRowExpanded: function toggleRowExpanded(payload) {
        this.$emit('update:expandedRowIds', dxGridCore.toggleRowExpanded(this.expandedRowIds, payload));
      }
    },
    render: function render() {
      var h = arguments[0];

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxTreeDataState'
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'expandedRowIds', value: this.expandedRowIds }
        }), h(dxVueCore.DxAction, {
          attrs: { name: 'toggleRowExpanded', action: this.toggleRowExpanded }
        })]
      );
    }
  };

  var pluginDependencies$f = [{ name: 'DxTreeDataState' }];

  var expandedTreeRowsComputed = function expandedTreeRowsComputed(_ref) {
    var rows = _ref.rows,
        getRowId = _ref.getRowId,
        expandedRowIds = _ref.expandedRowIds;
    return dxGridCore.expandedTreeRows(rows, getRowId, expandedRowIds);
  };
  var getRowIdComputed$1 = function getRowIdComputed(_ref2) {
    var getRowId = _ref2.getRowId,
        rows = _ref2.rows;
    return dxGridCore.customTreeRowIdGetter(getRowId, rows);
  };
  var getRowLevelKeyComputed = function getRowLevelKeyComputed(_ref3) {
    var getRowLevelKey = _ref3.getRowLevelKey,
        rows = _ref3.rows;
    return dxGridCore.customTreeRowLevelKeyGetter(getRowLevelKey, rows);
  };
  var isTreeRowLeafComputed = function isTreeRowLeafComputed(_ref4) {
    var rows = _ref4.rows;
    return dxGridCore.isTreeRowLeafGetter(rows);
  };
  var getTreeRowLevelComputed = function getTreeRowLevelComputed(_ref5) {
    var rows = _ref5.rows;
    return dxGridCore.getTreeRowLevelGetter(rows);
  };
  var collapsedTreeRowsGetterComputed = function collapsedTreeRowsGetterComputed(_ref6) {
    var rows = _ref6.rows,
        getCollapsedRows = _ref6.getCollapsedRows;
    return dxGridCore.collapsedTreeRowsGetter(getCollapsedRows, rows);
  };
  var unwrappedTreeRowsComputed = function unwrappedTreeRowsComputed(_ref7) {
    var rows = _ref7.rows;
    return dxGridCore.unwrappedCustomTreeRows(rows);
  };

  var DxCustomTreeData = {
    name: 'DxCustomTreeData',
    props: {
      getChildRows: {
        type: Function,
        required: true
      }
    },
    render: function render() {
      var h = arguments[0];
      var getChildRows = this.getChildRows;

      var treeRowsComputed = function treeRowsComputed(_ref8) {
        var rows = _ref8.rows;
        return dxGridCore.customTreeRowsWithMeta(rows, getChildRows);
      };

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'CustomTreeData',
            dependencies: pluginDependencies$f
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'rows', computed: treeRowsComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'getRowId', computed: getRowIdComputed$1 }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'getRowLevelKey', computed: getRowLevelKeyComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'isTreeRowLeaf', computed: isTreeRowLeafComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'getTreeRowLevel', computed: getTreeRowLevelComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'rows', computed: expandedTreeRowsComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'getCollapsedRows', computed: collapsedTreeRowsGetterComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'rows', computed: unwrappedTreeRowsComputed }
        })]
      );
    }
  };

  var DxTableTreeColumn = {
    name: 'DxTableTreeColumn',
    props: {
      for: {
        type: String,
        required: true
      },
      showSelectionControls: {
        type: Boolean,
        default: false
      },
      showSelectAll: {
        type: Boolean,
        default: false
      },
      cellComponent: {
        type: Object,
        required: true
      },
      indentComponent: {
        type: Object,
        required: true
      },
      expandButtonComponent: {
        type: Object,
        required: true
      },
      checkboxComponent: {
        type: Object,
        required: true
      },
      contentComponent: {
        type: Object,
        required: true
      }
    },
    render: function render() {
      var h = arguments[0];
      var forColumnName = this.for,
          showSelectionControls = this.showSelectionControls,
          showSelectAll = this.showSelectAll,
          Indent = this.indentComponent,
          ExpandButton = this.expandButtonComponent,
          Checkbox = this.checkboxComponent,
          Content = this.contentComponent,
          Cell = this.cellComponent;


      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxTableTreeColumn',
            dependencies: [{ name: 'DxDataTypeProvider', optional: true }, { name: 'DxTreeDataState' }, { name: 'DxSelectionState', optional: !showSelectionControls }, { name: 'DxIntegratedSelection', optional: !showSelectAll }, { name: 'DxTable' }, { name: 'DxTableHeaderRow', optional: true }]
          }
        },
        [h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableHeaderCellBefore',
              predicate: function predicate(_ref) {
                var column = _ref.attrs.column;
                return column.name === forColumnName;
              }
            }
          },
          [h(
            'div',
            { style: 'display: flex' },
            [h(ExpandButton, {
              attrs: {
                visible: false
              }
            }), showSelectionControls && showSelectAll && h(dxVueCore.DxTemplateConnector, [function (_ref2) {
              var _ref2$getters = _ref2.getters,
                  selectAllAvailable = _ref2$getters.selectAllAvailable,
                  allSelected = _ref2$getters.allSelected,
                  someSelected = _ref2$getters.someSelected,
                  toggleSelectAll = _ref2.actions.toggleSelectAll;
              return h(Checkbox, {
                attrs: {
                  disabled: !selectAllAvailable,
                  checked: allSelected,
                  indeterminate: someSelected
                },
                on: {
                  'change': toggleSelectAll
                }
              });
            }])]
          )]
        ), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableCell',
              predicate: function predicate(_ref3) {
                var _ref3$attrs = _ref3.attrs,
                    tableRow = _ref3$attrs.tableRow,
                    tableColumn = _ref3$attrs.tableColumn;
                return dxGridCore.isTreeTableCell(tableRow, tableColumn, forColumnName);
              }
            }
          },
          [function (_ref4) {
            var attrs = _ref4.attrs,
                listeners = _ref4.listeners;
            return h(dxVueCore.DxTemplateConnector, [function (_ref5) {
              var _ref5$getters = _ref5.getters,
                  getCollapsedRows = _ref5$getters.getCollapsedRows,
                  expandedRowIds = _ref5$getters.expandedRowIds,
                  selection = _ref5$getters.selection,
                  isTreeRowLeaf = _ref5$getters.isTreeRowLeaf,
                  getTreeRowLevel = _ref5$getters.getTreeRowLevel,
                  getCellValue = _ref5$getters.getCellValue,
                  _ref5$actions = _ref5.actions,
                  toggleRowExpanded = _ref5$actions.toggleRowExpanded,
                  toggleSelection = _ref5$actions.toggleSelection;
              var _attrs$tableRow = attrs.tableRow,
                  row = _attrs$tableRow.row,
                  rowId = _attrs$tableRow.rowId;

              var columnName = attrs.tableColumn.column.name;
              var value = getCellValue(row, columnName);
              var collapsedRows = getCollapsedRows(row);
              return h(
                dxVueCore.DxTemplatePlaceholder,
                {
                  attrs: {
                    name: 'valueFormatter',
                    row: row,
                    column: attrs.tableColumn.column,
                    value: value
                  }
                },
                [function (content) {
                  return h(
                    Cell,
                    babelHelperVueJsxMergeProps([{ attrs: _extends({}, attrs), on: _extends({}, listeners) }, {
                      attrs: {
                        row: row,
                        column: attrs.tableColumn.column,
                        value: value
                      }
                    }]),
                    [h(Indent, {
                      attrs: {
                        level: getTreeRowLevel(row)
                      }
                    }), h(ExpandButton, {
                      attrs: {
                        visible: collapsedRows ? !!collapsedRows.length : !isTreeRowLeaf(row),
                        expanded: expandedRowIds.indexOf(rowId) > -1
                      },
                      on: {
                        'toggle': function toggle() {
                          return toggleRowExpanded({ rowId: rowId });
                        }
                      }
                    }), showSelectionControls && h(Checkbox, {
                      attrs: {
                        disabled: false,
                        checked: selection.indexOf(rowId) > -1,
                        indeterminate: false
                      },
                      on: {
                        'change': function change() {
                          return toggleSelection({ rowIds: [rowId] });
                        }
                      }
                    }), h(Content, [content || value])]
                  );
                }]
              );
            }]);
          }]
        )]
      );
    }
  };

  var CellPlaceholder$1 = {
    render: function render() {
      var h = arguments[0];

      return h(dxVueCore.DxTemplatePlaceholder);
    }
  };

  var DxTableBandHeader = {
    name: 'DxTableBandHeader',
    props: {
      columnBands: {
        type: Array
      },
      cellComponent: {
        type: Object
      },
      rowComponent: {
        type: Object
      },
      bandedHeaderCellComponent: {
        type: Object
      },
      invisibleCellComponent: {
        type: Object
      }
    },
    render: function render() {
      var h = arguments[0];
      var Cell = this.cellComponent,
          Row = this.rowComponent,
          HeaderCell = this.bandedHeaderCellComponent,
          InvisibleCell = this.invisibleCellComponent,
          columnBands = this.columnBands;


      var tableHeaderRowsComputed = function tableHeaderRowsComputed(_ref) {
        var tableHeaderRows = _ref.tableHeaderRows,
            tableColumns = _ref.tableColumns;
        return dxGridCore.tableRowsWithBands(tableHeaderRows, columnBands, tableColumns);
      };

      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxTableBandHeader',
            dependencies: [{ name: 'DxTable' }, { name: 'DxTableHeaderRow' }, { name: 'DxTableSelection', optional: true }, { name: 'DxTableEditColumn', optional: true }]
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'tableHeaderRows', computed: tableHeaderRowsComputed }
        }), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableCell',
              predicate: function predicate(_ref2) {
                var tableRow = _ref2.attrs.tableRow;
                return dxGridCore.isBandedOrHeaderRow(tableRow);
              }
            }
          },
          [function (_ref3) {
            var attrs = _ref3.attrs;
            return h(dxVueCore.DxTemplateConnector, [function (_ref4) {
              var _ref4$getters = _ref4.getters,
                  tableColumns = _ref4$getters.tableColumns,
                  tableHeaderRows = _ref4$getters.tableHeaderRows;

              var bandComponent = dxGridCore.getBandComponent(attrs, tableHeaderRows, tableColumns, columnBands);

              switch (bandComponent.type) {
                case dxGridCore.BAND_DUPLICATE_RENDER:
                  return h(dxVueCore.DxTemplatePlaceholder, {
                    attrs: {
                      colSpan: attrs.colSpan,
                      tableColumn: attrs.tableColumn,
                      tableRow: attrs.tableRow,
                      rowSpan: attrs.rowSpan
                    }
                  });
                case dxGridCore.BAND_EMPTY_CELL:
                  return h(InvisibleCell);
                case dxGridCore.BAND_GROUP_CELL:
                  {
                    var _bandComponent$payloa = bandComponent.payload,
                        value = _bandComponent$payloa.value,
                        payload = objectWithoutProperties(_bandComponent$payloa, ['value']);

                    return h(
                      Cell,
                      { attrs: _extends({}, attrs, payload) },
                      [value]
                    );
                  }
                case dxGridCore.BAND_HEADER_CELL:
                  return h(dxVueCore.DxTemplatePlaceholder, {
                    attrs: {
                      name: 'tableCell',
                      colSpan: attrs.colSpan,
                      tableColumn: attrs.tableColumn,
                      tableRow: bandComponent.payload.tableRow,
                      rowSpan: bandComponent.payload.rowSpan
                    }
                  });
                default:
                  return null;
              }
            }]);
          }]
        ), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableCell',
              predicate: function predicate(_ref5) {
                var _ref5$attrs = _ref5.attrs,
                    tableRow = _ref5$attrs.tableRow,
                    tableColumn = _ref5$attrs.tableColumn;
                return dxGridCore.isHeadingTableCell(tableRow, tableColumn);
              }
            }
          },
          [function (_ref6) {
            var attrs = _ref6.attrs;
            return h(HeaderCell, babelHelperVueJsxMergeProps([{
              attrs: { component: CellPlaceholder$1 }
            }, { attrs: _extends({}, attrs) }]));
          }]
        ), h(
          dxVueCore.DxTemplate,
          {
            attrs: {
              name: 'tableRow',
              predicate: function predicate(_ref7) {
                var tableRow = _ref7.attrs.tableRow;
                return dxGridCore.isBandedTableRow(tableRow);
              }
            }
          },
          [function (_ref8) {
            var attrs = _ref8.attrs,
                slots = _ref8.slots;
            return h(
              Row,
              { attrs: _extends({}, attrs) },
              [slots.default]
            );
          }]
        )]
      );
    }
  };

  var pluginDependencies$g = [{ name: 'DxTable' }];

  var visibleTableColumnsComputed = function visibleTableColumnsComputed(_ref) {
    var tableColumns = _ref.tableColumns,
        hiddenColumnNames = _ref.hiddenColumnNames;
    return dxGridCore.visibleTableColumns(tableColumns, hiddenColumnNames);
  };

  var columnExtensionValueGetter$3 = function columnExtensionValueGetter(columnExtensions, defaultValue) {
    return dxGridCore.getColumnExtensionValueGetter(columnExtensions, 'togglingEnabled', defaultValue);
  };

  var DxTableColumnVisibility = {
    name: 'DxTableColumnVisibility',
    props: {
      hiddenColumnNames: {
        type: Array,
        required: true
      },
      emptyMessageComponent: {
        type: Object,
        required: true
      },
      messages: {
        type: Object
      },
      columnExtensions: {
        type: Array
      },
      columnTogglingEnabled: {
        type: Boolean,
        default: true
      }
    },
    methods: {
      toggleColumnVisibility: function toggleColumnVisibility(columnName) {
        this.$emit('update:hiddenColumnNames', dxGridCore.toggleColumn(this.hiddenColumnNames, columnName));
      }
    },
    render: function render() {
      var h = arguments[0];
      var EmptyMessage = this.emptyMessageComponent,
          messages = this.messages,
          hiddenColumnNames = this.hiddenColumnNames,
          columnExtensions = this.columnExtensions,
          columnTogglingEnabled = this.columnTogglingEnabled;

      var getMessage = dxCore.getMessagesFormatter(messages);
      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxTableColumnVisibility',
            dependencies: pluginDependencies$g
          }
        },
        [h(dxVueCore.DxGetter, {
          attrs: { name: 'hiddenColumnNames', value: hiddenColumnNames }
        }), h(dxVueCore.DxGetter, {
          attrs: { name: 'tableColumns', computed: visibleTableColumnsComputed }
        }), h(dxVueCore.DxGetter, {
          attrs: {
            name: 'isColumnTogglingEnabled',
            value: columnExtensionValueGetter$3(columnExtensions, columnTogglingEnabled)
          }
        }), h(dxVueCore.DxAction, {
          attrs: {
            name: 'toggleColumnVisibility',
            action: this.toggleColumnVisibility
          }
        }), h(
          dxVueCore.DxTemplate,
          {
            attrs: { name: 'table' }
          },
          [function (attrs) {
            return h(dxVueCore.DxTemplateConnector, [function (_ref2) {
              var tableColumns = _ref2.getters.tableColumns;
              return dxGridCore.tableDataColumnsExist(tableColumns) ? h(dxVueCore.DxTemplatePlaceholder) : h(EmptyMessage, babelHelperVueJsxMergeProps([{
                attrs: {
                  getMessage: getMessage
                }
              }, { attrs: attrs }]));
            }]);
          }]
        )]
      );
    }
  };

  var pluginDependencies$h = [{ name: 'DxTableColumnVisibility' }, { name: 'DxToolbar' }];
  var DxColumnChooser = {
    name: 'DxColumnChooser',
    props: {
      overlayComponent: {
        type: Object,
        required: true
      },
      containerComponent: {
        type: Object,
        required: true
      },
      itemComponent: {
        type: Object,
        required: true
      },
      toggleButtonComponent: {
        type: Object,
        required: true
      }
    },
    data: function data() {
      return {
        visible: false
      };
    },

    methods: {
      setButtonRef: function setButtonRef(button) {
        this.button = button;
      },
      handleToggle: function handleToggle() {
        this.visible = !this.visible;
      },
      handleHide: function handleHide() {
        this.visible = false;
      }
    },
    render: function render() {
      var _this = this;

      var h = arguments[0];
      var Overlay = this.overlayComponent,
          Container = this.containerComponent,
          Item = this.itemComponent,
          ToggleButton = this.toggleButtonComponent,
          visible = this.visible;


      return h(
        dxVueCore.DxPlugin,
        {
          attrs: {
            name: 'DxColumnChooser',
            dependencies: pluginDependencies$h
          }
        },
        [h(
          dxVueCore.DxTemplate,
          {
            attrs: { name: 'toolbarContent' }
          },
          [h(
            'div',
            { style: { display: 'flex', flex: 1 } },
            [h(dxVueCore.DxTemplatePlaceholder), h(dxVueCore.DxTemplateConnector, [function (_ref) {
              var _ref$getters = _ref.getters,
                  columns = _ref$getters.columns,
                  hiddenColumnNames = _ref$getters.hiddenColumnNames,
                  isColumnTogglingEnabled = _ref$getters.isColumnTogglingEnabled,
                  toggleColumnVisibility = _ref.actions.toggleColumnVisibility;
              return h(
                'div',
                { style: { display: 'flex', alignItems: 'center', position: 'relative' } },
                [h(ToggleButton, {
                  attrs: {
                    buttonRef: _this.setButtonRef,

                    active: visible
                  },
                  on: {
                    'toggle': _this.handleToggle
                  }
                }), h(
                  Overlay,
                  {
                    attrs: {
                      visible: visible,
                      target: _this.button
                    },
                    on: {
                      'hide': _this.handleHide
                    }
                  },
                  [h(Container, [dxGridCore.columnChooserItems(columns, hiddenColumnNames).map(function (item) {
                    var columnName = item.column.name;

                    var togglingEnabled = isColumnTogglingEnabled(columnName);
                    return h(Item, {
                      key: columnName,
                      attrs: { item: item,
                        disabled: !togglingEnabled
                      },
                      on: {
                        'toggle': function toggle() {
                          return toggleColumnVisibility(columnName);
                        }
                      }
                    });
                  })])]
                )]
              );
            }])]
          )]
        )]
      );
    }
  };

  exports.DxGrid = DxGrid;
  exports.DxTable = DxTable;
  exports.DxTableHeaderRow = DxTableHeaderRow;
  exports.DxIntegratedSorting = DxIntegratedSorting;
  exports.DxSortingState = DxSortingState;
  exports.DxToolbar = DxToolbar;
  exports.TableLayout = TableLayout;
  exports.StaticTableLayout = StaticTableLayout;
  exports.VirtualTableLayout = VirtualTableLayout;
  exports.DxFilteringState = DxFilteringState;
  exports.DxIntegratedFiltering = DxIntegratedFiltering;
  exports.DxTableFilterRow = DxTableFilterRow;
  exports.DxGroupingState = DxGroupingState;
  exports.DxIntegratedGrouping = DxIntegratedGrouping;
  exports.DxCustomGrouping = DxCustomGrouping;
  exports.DxGroupingPanel = DxGroupingPanel;
  exports.DxTableGroupRow = DxTableGroupRow;
  exports.GroupPanelLayout = GroupPanelLayout;
  exports.DxSearchState = DxSearchState;
  exports.DxSearchPanel = DxSearchPanel;
  exports.DxSelectionState = DxSelectionState;
  exports.DxIntegratedSelection = DxIntegratedSelection;
  exports.DxTableSelection = DxTableSelection;
  exports.DxPagingState = DxPagingState;
  exports.DxIntegratedPaging = DxIntegratedPaging;
  exports.DxCustomPaging = DxCustomPaging;
  exports.DxPagingPanel = DxPagingPanel;
  exports.DxDataTypeProvider = DxDataTypeProvider;
  exports.DxRowDetailState = DxRowDetailState;
  exports.DxTableRowDetail = DxTableRowDetail;
  exports.DxEditingState = DxEditingState;
  exports.DxTableEditColumn = DxTableEditColumn;
  exports.DxTableEditRow = DxTableEditRow;
  exports.DxTreeDataState = DxTreeDataState;
  exports.DxCustomTreeData = DxCustomTreeData;
  exports.DxTableTreeColumn = DxTableTreeColumn;
  exports.DxTableBandHeader = DxTableBandHeader;
  exports.DxTableColumnVisibility = DxTableColumnVisibility;
  exports.DxColumnChooser = DxColumnChooser;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=dx-vue-grid.umd.js.map
